####################################################
# Windrop  Vladislav 
# : kns
# : 0.3
# :  / ,   RusNet.
# : !+x !-x
####################################################

set ns "::dh"
catch { ${ns}::uninstall }

namespace eval $ns {
variable chflag [namespace tail [namespace current]]
variable pubflag "-|-"
variable usage ": %bind% </>"
variable frmt "$::gcolor(14)%bf% -> $::gcolor(5)%aft%"
variable cmd
variable delay 10

setudef flag no$chflag

variable unxbinds [list "-x" "-" "$::gprefix(1)-" "$::gprefix(1)-x"]
variable xbinds [list "+x" "+" "$::gprefix(1)+" "$::gprefix(1)+x"]

foreach tmp $unxbinds {bind pub $pubflag $tmp [list "[namespace current]::pubq" 0]; bind msg $pubflag $tmp [list "[namespace current]::msgq" 0]}
foreach tmp $xbinds {bind pub $pubflag $tmp [list "[namespace current]::pubq" 1]; bind msg $pubflag $tmp [list "[namespace current]::msgq" 1]}
unset tmp

proc stripspaces { ustr } {
set ustr [string map { {}} [stripcodes bcur $ustr]]
regsub -all -- {\s+} $ustr { } ustr
set ustr [string trim $ustr]
return $ustr
}

proc out { tp ustr } {
upvar 1 unick nick
upvar 1 uchan chan
set m "PRIVMSG"
if {![validchan $chan]} {set chan $nick} elseif {[string equal $tp "warn"]} {set m "NOTICE"; set chan $nick}
putserv "$m $chan :$ustr"
return
}

proc msgq { {tp 0} unick uhost uhand ustr } {pubq $tp $unick $uhost $uhand $uhost $ustr}

proc pubq { {tp 0} unick uhost uhand uchan ustr } {
variable chflag; variable usage; variable delay; variable cmd
if {[validchan $uchan]} {if {[channel get $uchan no$chflag]} {return 0}}
if {[info exists cmd(last,${uchan})]} {
set ld [expr {[clock seconds] - $cmd(last,${uchan})}]
if {$ld < [expr {$delay - 1}]} {out warn "  ,    [expr {$delay - $ld}] ."; return 0}
}
set cmd(last,${uchan}) [clock seconds]
set ustr [lindex [split [stripspaces $ustr]] 0]
set ustr [lindex [split $ustr @] end]
regsub -all -- {[^a-zA-Z0-9_\.\-`\{\}\[\]]+} $ustr {} ustr
if {$ustr eq ""} {out warn [string map [list "%bind%" $::lastbind] $usage]; return
} elseif {[onchan $ustr]} {set ustr [lindex [split [getchanhost $ustr] "@"] end]}
get_httpdata $tp "http://rusnet.kikimor.ru/" $ustr [list $unick $uhost $uhand $uchan $ustr]
unset unick uhost uhand uchan ustr
return
}

proc get_parse { extra token } {
variable frmt
set data [encoding convertfrom cp1251 [::http::data $token]]
set data [string map [list "\n" ""] $data]
::http::cleanup $token
regsub -all -- {<b>} $data {} data; regsub -all -- {</b>} $data {} data; regsub -all -- {<br.*?>} $data {} data; regsub -all -- {<img.*?>} $data {} data
if {[regexp -- {<h2>(.*?)</h2>} $data -> data]} { if {[string match -nocase "*=*" $data]} {set data [string trim [lindex [split $data "="] 1]]} } {set data "$::gcolor(4) ."}
set unick [lindex $extra 0]
set uchan [lindex $extra 3]
out norm [string map [list "%bf%" [lindex $extra 4] "%aft%" ${data}] $frmt]
unset data extra unick uchan
return
}

proc get_httpdata { tp url ip extra} {
variable chflag
::http::config -useragent "Opera/9.52 (Windows NT 5.1; U; en)"
if {[catch  { set token  [::http::geturl $url -command "[namespace current]::get_parse {$extra}" -timeout 15000 -blocksize 32768 -binary true -query [::http::formatQuery "dhtext" $ip "encode" $tp] -headers [list "Referer" $url] ] } errMsg]} {putlog ":: $chflag :: $errMsg"}
unset tp url ip extra
return
}

bind evnt - prerehash [namespace current]::uninstall
proc uninstall {args} {
foreach bind [binds "[namespace current]::*"] {
catch {unbind [lindex $bind 0] [lindex $bind 1] [lindex $bind 2] [lindex $bind 4]}
}
unset bind
namespace delete [namespace current]
}
return
}