####################################################
# Windrop  Vladislav 
# : Unlimited mod Vladislav
# : 0.27
# :    .
# : !
####################################################

setudef flag nodecode
setudef flag noadecode

bind pub - $::gprefix(1) decode
bind pubm - ** check_decode

set max_word_len 20

set decode_msg { ", ,  :" ", -,  :" ",    :" }
set rus_dict { "djn" "yt" "vyt" "nen" "fuf" "eue" "ghbdtn" "cfv" "nfr" "rfr" "ytn" "xnj" "jr" "vyt" "gjyznyj" "rhenf" }
set lat_dict { "windows" "unix" "linyx" "eggdrop" "windrop" "wget" "tar" "make" "gmake" "install" "scripts" "data" "set" "server" "cd" "new" }
set inword_lat_dict { "ctrl" "ftp" "http" "html" "tcl" }

proc decode {nick uhost hand chan text} {
if {[channel get $chan nodecode]} { return }
if { $text == "" } { puthelp "NOTICE $nick :: $::gprefix(1) <>"; return }
set message "[lat_to_rus $text]"
putchan $chan $message
}

proc check_decode {nick uhost hand chan text} {
if {[channel get $chan noadecode]} return
global decode_msg max_word_len
set word_qua [llength $text]
set word_cnt 0
set put 0
if {[text_has_rus $text]} { return 0 }
while {$word_cnt < $word_qua} {
set cur_word [lindex $text $word_cnt]
set cur_word_len [string length $cur_word]
if { $cur_word_len > $max_word_len || [word_onchan $cur_word $chan] || [word_is_url $cur_word] || [word_is_lat $cur_word]} {
set word_decode($word_cnt) 0
} else {
set word_decode($word_cnt) 1
if {[word_is_rus $cur_word] || [word_need_to_decode $cur_word]} {
set put 1 
}
}
incr word_cnt
}
if { $put == 1 } {
set new_text ""
set word_cnt 0
while {$word_cnt < $word_qua} {
set cur_word [lindex $text $word_cnt]
if { $word_decode($word_cnt) == 1 } {
lappend new_text [lat_to_rus $cur_word]
} else {
lappend new_text $cur_word
}
incr word_cnt
}
set message "$nick[lindex $decode_msg [rand [llength $decode_msg ]]] [join $new_text]"
putchan $chan $message
}
return 0
}

proc word_need_to_decode {word} {
set len [string length $word]
set cnt 0
set cons_cnt 0
set dubl 0
set prev_char o
while {$cnt < $len} {
set curr_char [string index $word $cnt]
if {[is_lat_cons $curr_char]} {
incr cons_cnt
if {$prev_char == $curr_char} {
incr dubl
} else {
set dubl 0
}
} else {
set cons_cnt 0
}
if { $cons_cnt > 3 && $dubl < 2 } {
return 1
}
set prev_char $curr_char
incr cnt
}
return 0
}

proc word_is_rus {word} {
global rus_dict
regsub -all -nocase {[^a-z]} $word "" word
if {[lsearch -exact $rus_dict [string tolower $word]] > -1} {
return 1
} else {
return 0
}
}

proc word_is_lat {word} {
global lat_dict inword_lat_dict
regsub -all -nocase {[^a-z]} $word "" word
set word [string tolower $word]
set cnt 0
set len [llength $inword_lat_dict]
while {$cnt < $len} {
if {[string match *[lindex $inword_lat_dict $cnt]* $word]} {
return 1
}
incr cnt
}
if {[lsearch -exact $lat_dict [string tolower $word]] > -1} {
return 1
} else {
return 0
}
}

proc word_is_url {word} {
if {[string match irc* $word] || [string match *windrop* $word] || [string match *eggdrop* $word] || [string match *tmp* $word] || [string match *prefix* $word] || [string match *conf* $word] || [string match *.tcl $word] || [string match http:* $word] || [string match https:* $word] || [string match ftp:* $word] || [string match ftp.* $word] || [string match www.* $word] || [string match *.ru* $word]} {
return 1
} else {
return 0
}
}

proc word_onchan {word chan} {
regsub -all -nocase {[:,.?!]} $word "" nick
if {[onchan $nick $chan]} {
return 1
} else {
regsub -all -nocase {[\[\]]} $word "" nick
if {[onchan $nick $chan]} {
return 1
}
return 0
}
}

proc is_lat_cons {letter} {
set caps {B C D F G H J K L M N P Q R S T V W X Z b c d f g h j k l m n p q r s t v w x z [ ] ; ` ~}
if {[lsearch -exact $caps $letter] > -1} {
return 1
} else {
return 0
}
}

proc text_has_rus {text} {
set len [string length $text]
set cnt 0
while {$cnt < $len} {
if {[is_rus [string index $text $cnt]]} {
return 1
}
incr cnt
}
return 0
}

proc is_rus {letter} {
set caps {                                                                 }
if {[lsearch -exact $caps $letter] > -1} {
return 1
} else {
return 0
}
}

proc lat_to_rus {text} { return [string map {q  w  e  r  t  y  u  i  o  p  [  ]  a  s  d  f  g  h  j  k  l  ;  '  z  x  c  v  b  n  m  ,  .  / . Q  W  E  R  T  Y  U  I  O  P  \{  \}  A  S  D  F  G  H  J  K  L  :  \"  Z  X  C  V  B  N  M  <  >  ? , ^ : & ? `  ~  $ ;} $text] }