####################################################
# Windrop  Vladislav 
# : anaesthesia
# : 1.7
# : 
# : !
####################################################

namespace eval acro {

variable acronymcmd  "acro"
variable acronymcmdr ""
variable acronymflag noacro
variable maxdef 4
variable apriv 1

setudef flag $acronymflag
variable useragent "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.1) Gecko/20061204 Firefox/2.0.0.1"
variable acronymurl "http://acronyms.thefreedictionary.com/"
variable useragentr "Mozilla/4.0 (compatible; MSIE 4.01; Windows CE; PPC; 240x320)"	
variable acronymurlr "http://pda.sokr.ru/"

bind pub -|- $::gprefix(1)$acronymcmd ::acro::acronym_pub
bind pub -|- $::gprefix(1)$acronymcmdr ::acro::acronym_pub
bind msg - $::gprefix(1)$acronymcmd ::acro::acronym_msg
bind msg - $::gprefix(1)$acronymcmdr ::acro::acronym_msg

proc acronym_pub {nick host hand chan arg} {
variable acronymflag
if {[channel get $chan $acronymflag]} {return}
acron $nick $host $hand $chan $arg
}

proc acronym_msg {nick host hand arg} {
variable apriv
if {!$apriv} {return}
acron $nick $host $hand $nick $arg
}

proc urlenc {content {codepage {}} {type {1}}} {
if {$codepage ne ""} {set content [encoding convertto $codepage $content]}
if {$type} {
set str "" ; foreach byte [split $content ""] {scan $byte %c i ; if {[string match {[%<>"]} $byte] || $i < 65 || $i > 122} {append str [format %%%02X $i]} {append str $byte}}
return [string map {%3A : %2D - %2E . %30 0 %31 1 %32 2 %33 3 %34 4 %35 5 %36 6 %37 7 %38 8 %39 9 \[ %5B \\ %5C \] %5D \^ %5E \_ %5F \` %60} $str]
} {
set str "" ; foreach byte [split $content ""] {scan $byte %c i ; append str "[format %02X $i] "}
return $str
}
}

proc sconv {strr} {
set smaps {
&quot;     '     &apos;     \x27  &amp;      \x26  &lt;       \x3C   &gt;       \x3E  &nbsp;     \x20
&iexcl;    \xA1  &curren;   \xA4  &cent;     \xA2  &pound;    \xA3   &yen;      \xA5  &brvbar;   \xA6
&sect;     \xA7  &uml;      \xA8  &copy;     \xA9  &ordf;     \xAA   &laquo;    \xAB  &not;      \xAC
&shy;      \xAD  &reg;      \xAE  &macr;     \xAF  &deg;      \xB0   &plusmn;   \xB1  &sup2;     \xB2
&sup3;     \xB3  &acute;    \xB4  &micro;    \xB5  &para;     \xB6   &middot;   \xB7  &cedil;    \xB8
&sup1;     \xB9  &ordm;     \xBA  &raquo;    \xBB  &frac14;   \xBC   &frac12;   \xBD  &frac34;   \xBE
&iquest;   \xBF  &times;    \xD7  &divide;   \xF7  &Agrave;   \xC0   &Aacute;   \xC1  &Acirc;    \xC2
&Atilde;   \xC3  &Auml;     \xC4  &Aring;    \xC5  &AElig;    \xC6   &Ccedil;   \xC7  &Egrave;   \xC8
&Eacute;   \xC9  &Ecirc;    \xCA  &Euml;     \xCB  &Igrave;   \xCC   &Iacute;   \xCD  &Icirc;    \xCE
&Iuml;     \xCF  &ETH;      \xD0  &Ntilde;   \xD1  &Ograve;   \xD2   &Oacute;   \xD3  &Ocirc;    \xD4
&Otilde;   \xD5  &Ouml;     \xD6  &Oslash;   \xD8  &Ugrave;   \xD9   &Uacute;   \xDA  &Ucirc;    \xDB
&Uuml;     \xDC  &Yacute;   \xDD  &THORN;    \xDE  &szlig;    \xDF   &agrave;   \xE0  &aacute;   \xE1
&acirc;    \xE2  &atilde;   \xE3  &auml;     \xE4  &aring;    \xE5   &aelig;    \xE6  &ccedil;   \xE7
&egrave;   \xE8  &eacute;   \xE9  &ecirc;    \xEA  &euml;     \xEB   &igrave;   \xEC  &iacute;   \xED
&icirc;    \xEE  &iuml;     \xEF  &eth;      \xF0  &ntilde;   \xF1   &ograve;   \xF2  &oacute;   \xF3
&ocirc;    \xF4  &otilde;   \xF5  &ouml;     \xF6  &oslash;   \xF8   &ugrave;   \xF9  &uacute;   \xFA
&ucirc;    \xFB  &uuml;     \xFC  &yacute;   \xFD  &thorn;    \xFE   &yuml;     \xFF  
\"         '     &ldquo;    `     &rdquo;    '     &ndash;    "-"    &mdash;    "-"	  &dagger; 	" . "
\{         (     \}          )	
}
set ret ""
while { [regexp {^(.*?)&#(\d{1,4});(.*)$} $strr - p e strr] } {
append ret $p [format %c $e]
}
set strr [append ret $strr]
return [string map -nocase $smaps $strr]
}

proc chkrus {strr} {
set len [string length $strr]
set cnt 0
while {$cnt < $len} {
if {[regexp -all -- {[ި]} [string index $strr $cnt]]} {return 1}
incr cnt
}
return 0
}

proc scount {subs string} {regsub -all $subs $string $subs string}
proc sspace {strr} {return [string trim [regsub -all {[\t\s]+} $strr { }]]}

proc acron {nick host hand chan arg}  {
variable useragent 
variable useragentr
variable acronymurl
variable acronymurlr
variable acronymcmd
variable acronymcmdr
variable maxdef
set arg [string trim $arg]
if {$arg == ""} {acronym_syntax $nick} else {
putcmdlog "$nick $chan $::lastbind $arg"
set res ""
if { [regexp -nocase -- {[-|+](\d+)\s*} $arg -> mpg] } { 
set mpage $mpg
regsub -- {[-|+]\d+\s*} $arg "" arg
} else {set mpage 0}
if {[chkrus $arg]} {
set url "$acronymurlr[urlenc $arg utf-8]/"
::http::config -useragent $useragentr
set token [::http::geturl $url -timeout 3000]
if {[::http::status $token] == "ok"} {
regexp {</form>(.*)</body>} [::http::data $token] -> res
regsub -all -- "\n|\r|\t" $res "" res
regexp -all -nocase -- {<p class="search_stat">(.*?)</p>} $res -> numresults ; regexp -- {(\d+)} [string map {"&#133;" ""} $numresults] -> numresults
regsub -all -- "</td>" $res "\n" res
if {$numresults != "0" && ![string match "*  *" $numresults]} {
set counter 1
if {$numresults == 1} {
puthelp "privmsg $chan :$::gcolor(14)\[$::gcolor(6)1$::gcolor(14)/1\]"
} elseif {$numresults >1 && [expr $mpage * $maxdef] <= $numresults} {
puthelp "privmsg $chan :$::gcolor(14)\[$::gcolor(6)[expr ($mpage * $maxdef) + 1]$::gcolor(14)-$::gcolor(6)[expr [expr (($mpage + 1) * $maxdef)] > $numresults ? $numresults : [expr (($mpage + 1) * $maxdef)]]$::gcolor(14)/$numresults\]"
} else { puthelp "NOTICE $nick : ." }
foreach rline [split $res \n] {
if {[regexp -nocase -- {<p class="value">(.*?)</p>.*?<p class="comment">(.*?)</p>.*?<p class="dates">(.*?)</p>(.*?)$} $rline -> rname rdesc rdate rdop]} {
if {[regexp -nocase -- {<p class="tag_list">(.*?)</p>} $rdop -> rmisc]} {regsub -all -- "<.*?>" $rmisc { } rmisc} {set rmisc ""}		
regsub -all -- "<br>" $rname { / } rname
regsub -all -- "<.*?>" $rname { } rname
regsub -all -- "<.*?>" $rdesc { } rdesc
set rdesc [sconv $rdesc]; set rmisc [sspace $rmisc]; set rdate [sspace $rdate]
if {$rdesc == "" && $rmisc == "" && $rdate == ""} {set line $rname} {set line "$rname  $rdesc $::gcolor(14)$rmisc\003 $rdate"}
set line [string trim $line]; regsub -all {\s+} $line " " line
if {( $counter >= [expr $maxdef + ($mpage * $maxdef)]) && ($numresults > [expr $maxdef + ($mpage * $maxdef)])} {
set line "$line $::gcolor(14)($::gcolor(6)$::gprefix(1)$acronymcmdr \+[ expr $mpage + 1 ] $arg$::gcolor(14) -  $maxdef.)" 
}
if {$counter >= [expr ($mpage * $maxdef) + 1 ]} {
puthelp "privmsg $chan :$line"
}
if {( $counter >= [expr $maxdef + ($mpage * $maxdef)]) && ($numresults > [expr $maxdef + ($mpage * $maxdef)])} {return}
incr counter
}
}	
} else {puthelp "privmsg $chan :  ."}
} else {puthelp "privmsg $chan :Timeout."}
} else {
set url "$acronymurl[urlenc $arg]"
::http::config -useragent $useragent
set token [::http::geturl $url -timeout 3000]
if {[::http::status $token] == "ok"} {
regexp "<tr><th>Acronym</th><th>Definition</th></tr>(.+?)</table>" [::http::data $token] res
if {$res != ""} {
regsub -all "<th>Acronym</th><th>Definition</th>" $res "" res
regsub -all "</td></tr>" $res "\n" res
regsub -all "</td><td>" $res "  " res
regsub -all "<\[^<\]*>" $res "" res
regsub -all "</td></tr>" $res "</td></tr>\n" res
if {$res != ""} {
set numresults [scount "\n" $res]
set res [split $res "\n"]
set counter 1
if {$numresults == 1} {
puthelp "privmsg $chan :$::gcolor(14)\[$::gcolor(6)1$::gcolor(14)/1\]"
} elseif {$numresults >1 && [expr $mpage * $maxdef] <= $numresults} {
puthelp "privmsg $chan :$::gcolor(14)\[$::gcolor(6)[expr ($mpage * $maxdef) + 1]$::gcolor(14)-$::gcolor(6)[expr [expr (($mpage + 1) * $maxdef)] > $numresults ? $numresults : [expr (($mpage + 1) * $maxdef)]]$::gcolor(14)/$numresults\]"
} else { puthelp "NOTICE $nick : ." }
foreach line $res {
if {[string trim $line] != "" && [string trim $line] != " "} {
if {( $counter >= [expr $maxdef + ($mpage * $maxdef)]) && ($numresults > [expr $maxdef + ($mpage * $maxdef)])} { 
set line "$line $::gcolor(14)($::gcolor(6)$::gprefix(1)$acronymcmd \+[ expr $mpage + 1 ] $arg$::gcolor(14) - next $maxdef.)" 
}
if {$counter >= [expr ($mpage * $maxdef) + 1 ]} {puthelp "privmsg $chan :$line"}
if {( $counter >= [expr $maxdef + ($mpage * $maxdef)]) && ($numresults > [expr $maxdef + ($mpage * $maxdef)])} {break}
incr counter
}
}
}
} else {puthelp "privmsg $chan :  ."}
} else {puthelp "privmsg $chan :Timeout."}
::http::cleanup $token
}
}
}

proc acronym_syntax { nick } {
variable acronymcmdr
puthelp "NOTICE $nick :: $::gprefix(1)$acronymcmdr \[+\] <>"
return done
}
}