####################################################
# Windrop  Vladislav 
# : Vertigo
# : 0.8
# :     http://bash.im
# : 
# ! - 
# ! <> -    
# ! <> - 
# ! [-] -cache [   ] -   . 
#   "   ",         . : !bash -cache 408599
#     ,     .
####################################################

namespace eval ::bash {

foreach bind [binds [namespace current]::*] {
catch {unbind [lindex $bind 0] [lindex $bind 1] [lindex $bind 2] [lindex $bind 4]}
}

#  
set prefix $::gprefix(1)
#   [1-59]
variable timer "30"

bind pub - ${prefix} ::bash::pub
bind pub - ${prefix}bash ::bash::pub
bind msg - ${prefix} ::bash::msg
bind msg - ${prefix}bash ::bash::msg
bind time - "* * * * *" ::bash::time

variable cache {data/bash.tmp}
variable maxquotes 10
set ::bash::check(delay) "20"
variable timeout "10"
variable need_load 0
variable search 0

setudef flag nobash
setudef flag auto-bash

proc pub {nick uhost hand chan text} {
if {[channel get $chan nobash]} { return }
main $nick $uhost $hand $chan $text
}

proc msg {nick uhost hand text} {
main $nick $uhost $hand $nick $text
}

proc main {nick uhost hand chan text} {
variable cache
variable need_load
variable search
variable timeout
set search 0
set need_load 1
if {[info exists ::bash::check(lasttime,$uhost)] && [expr $::bash::check(lasttime,$uhost) + $::bash::check(delay)] > [clock seconds] && ![matchattr $hand n]} {
putserv "NOTICE $nick : $::lastbind      [::bash::duration [expr $::bash::check(delay) - [expr [clock seconds] - $::bash::check(lasttime,$uhost)]]]."
return
}
if {![file exists $cache]} {set file [open $cache w+]; close $file}
set file [open $cache r]
set lines [read $file]
close $file
if {![llength [split $lines]]} {set need_load 0}
set index ""
if {[regexp -- {^-(\d+)} $text -> index_]} {set index [scan $index_ %d]; regsub -- "-$index" $text "" text}
regsub -all -- "\x20\x20" $text "\x20" text
set text [string trim $text]
set quote [lindex [split $text]]
if {$text eq "-" || $text eq "-e" || $text eq "-cache"} {
set file [open $cache r]
set line [lrange [split [read $file] \n] 0 end-1]; close $file
putfast "PRIVMSG $chan :$::gcolor(14)  $::gcolor(4) [llength $line]$::gcolor(14) ,    $::gcolor(6) [format "%.2f" [expr [file size $cache] /1024.0 /1024.0]] $::gcolor(14).    [duration [expr [clock seconds] -[file mtime $cache]]] ."
return
}
if {[regexp -- {^-cache} $text] || [regexp -- {^-} $text] || [regexp -- {^-e} $text]} {
cache_get $nick $uhost $hand $chan $index $text
set ::bash::check(lasttime,$uhost) [clock seconds]
return
}
::http::config -urlencoding cp1251 -useragent "Opera/9.52 (Windows NT 5.1; ru)"
if {[string is digit $quote]} {set url "http://bash.im/quote/$quote"; set text $quote} else {
set url "http://bash.im/?text=[::http::formatQuery $text]"; set search 1}
if {$text eq ""} {set url "http://bash.im/random"}
set extra [list $nick $uhost $hand $chan $index $text]
set tok [::http::geturl $url -timeout [expr $timeout*1000] -command [list [namespace current]::data $extra]]
set ::bash::check(lasttime,$uhost) [clock seconds]
return
}

proc data { extra tok } {
variable cache
variable search
variable maxquotes
variable need_load
foreach {nick uhost hand chan index text} $extra {break}
set status [::http::status $tok]
set ncode [::http::ncode $tok]
if {$status ne "ok"} {
if {$status eq "error" && $need_load eq 0} {putserv "NOTICE $nick :error while processing your request, try again later. Sorry."; ::http::cleanup $tok; return 0}
if {$status eq "timeout" && $need_load eq 0} {putserv "NOTICE $nick :connect timeout, while processing your request, try again later. Sorry."; ::http::cleanup $tok; return 0}
}
if {$need_load eq 1 && $status ne "ok"} {
cache_get $nick $uhost $hand $chan $index $text
return
}
set html [::http::data $tok]
::http::cleanup $tok
regsub -all -- "\n|\r|\t" $html "" html
set html [string map {\x5C "!@!"} $html]
regsub -all -nocase -- "<div class=\"actions\">" $html "\n<div class=\"actions\">" html
set list [list]
foreach line [split $html \n] {
if {![regexp -nocase -- {<div class=\"actions\">.*?class=\"rating\">(.*?)</span>.*?class=\"date\">(.*?)</span>.*?<a href="/quote/(.*?)".*?class=\"text\">(.*?)</div>} $line -> rating date num content]} {continue}
lappend list [list $num $rating $date [string map {"!@!" "\x5C\x5C"} $content]]
}
if {$list eq {}} {
if {[string is digit $text]} {putserv "PRIVMSG $chan :$nick,  #$text  ."} else {putserv "PRIVMSG $chan :$nick,     \"$text\"  ."}
return 0
}
foreach _ $list {
lassign $_ num_ rating_ date_ content_
if {$rating_ eq "???"} {set rating_ " "}
if {[string match "*\\.\\.\\.*" $rating_]} {set rating_ ""}
set content_ [regsub -all -- {\s*\n*\s*\n+\s*} [webstrip [string map {"<div>" "" {&gt;} "\>" {&lt;} "\<" {&quot;} "\"" \x5c\x5c \x5c "<br />" \n "<br>" \n} $content_]] "\n"]
putcache [list $num_ $date_ [string map {\n \x1F} $content_] $rating_]
}
set total [llength $list]
if {$index eq ""} {set index "1"}
if {$index > "50"} {set index "50"}
set quote [lindex $list [expr $index-1]]
set num [lindex $quote 0]
set rating [lindex $quote 1]
if {$rating eq "???"} {set rating " "}
if {[string match "*\\.\\.\\.*" $rating]} {set rating ""}
set date [lindex $quote 2]
set content [lindex $quote 3]
set content [regsub -all -- {\s*\n*\s*\n+\s*} [webstrip [string map {"<div>" "" {&gt;} "\>" {&lt;} "\<" {&quot;} "\"" \x5c\x5c \x5c "<br />" \n "<br>" \n} $content]] "\n"]
set mode ""
if {$search eq 1} {set mode " \(\002\002\)"}
if {[string match -nocase "*  * *" $html]} {putserv "PRIVMSG $chan :$nick,      .     ."}
set lines [llength [split $content \n]]
if {$lines >= $maxquotes} {
if {$chan != $nick} {putserv "PRIVMSG $chan :$nick,  $num   ($lines ).      ."}
putserv "PRIVMSG $nick :$::gcolor(14)<------$mode $::gcolor(5)\#$num$::gcolor(14) ------>\017"
foreach _ [split $content \n] { if {$_ ne ""} {::ccs::put_msgdest $nick $_} }
putserv "PRIVMSG $nick :$::gcolor(14)=--- : $::gcolor(6)$rating$::gcolor(14); : $date ---="
} else {
putserv "PRIVMSG $chan :$::gcolor(14)<------$mode $::gcolor(5)\#$num$::gcolor(14) ------>\017"
foreach _ [split $content \n] { if {$_ ne ""} {::ccs::put_msgdest $chan $_} }
putserv "PRIVMSG $chan :$::gcolor(14)=--- : $::gcolor(6)$rating$::gcolor(14); : $date ---="
}
}

proc putcache {data} {
variable cache
set f [open $cache r]
set cdata [lrange [split [read $f] \n] 0 end-1]
close $f
if {![llength $cdata] || [lsearch -index 0 $cdata [lindex $data 0]] == "-1"} {
set f [open $cache a]
puts $f $data
flush $f
close $f
return
}
}

proc cache_get {nick uhost hand chan index text} {
variable cache
variable search
variable maxquotes
variable need_load
set text [string map {"-cache " "" "- " "" "- " ""} $text]
set f [open $cache r]
set list [lrange [split [read $f] \n] 0 end-1]
close $f
set total [llength $list]
if {$total eq 0} {putserv "NOTICE $nick : .     : \002$::gprefix(1)\002 (1  = 50 )"; return}
if {$index eq ""} {set index [rand $total]}
if {$index > $total} {set index $total}
if {[string is digit $text]} {
if {[set idx [lsearch -index 0 $list $text]] == "-1"} {
putserv "PRIVMSG $chan :     ."
return
} else {
set quote [lindex $list $idx]
}
} else {
set quote [lindex $list $index]
}
lassign $quote num date content rating
set lines [llength [split $content \x1F]]
if {$lines >= $maxquotes} {
if {$chan != $nick} {putserv "PRIVMSG $chan :$nick,  $num   ($lines ).      ."}
if {$total >1} {set sch " $::gcolor(6)$index$::gcolor(14)/$total"} else {set sch ""}
putserv "PRIVMSG $nick :$::gcolor(14)<------ (\002\002$sch) $::gcolor(5)\#$num$::gcolor(14) ------>\017"
foreach _ [split $content \x1F] { if {$_ ne ""} {::ccs::put_msgdest $nick $_} }
putserv "PRIVMSG $nick :$::gcolor(14)=--- : $::gcolor(6)$rating$::gcolor(14); : $date ---="
} else {
if {$total >1} {set sch " $::gcolor(6)$index$::gcolor(14)/$total"} else {set sch ""}
putserv "PRIVMSG $chan :$::gcolor(14)<------ (\002\002$sch) $::gcolor(5)\#$num$::gcolor(14) ------>\017"
foreach _ [split $content \x1F] { if {$_ ne ""} {::ccs::put_msgdest $chan $_} }
putserv "PRIVMSG $chan :$::gcolor(14)=--- : $::gcolor(6)$rating$::gcolor(14); : $date ---="
}
return
}

proc time {mins hours days weeks years} {
variable cache
variable timer
if {[expr [scan $mins %d]%$timer] != 0} {return}
set file [open $cache r]
set list [lrange [split [read $file] \n] 0 end-1]
close $file
set total [llength $list]
set chan ""
foreach _ [channels] {
if {[channel get $_ auto-bash]} {append chan $_,}
}
if {$chan eq ""} {
return
}
set chan [string range $chan 0 end-1]
if {$total eq 0} {putserv "PRIVMSG $chan : .     : \002$::gprefix(1)\002 (1  = 50 )"; return}
set index [rand $total]
set quote [lindex $list $index]
lassign $quote num date content rating
putserv "PRIVMSG $chan :$::gcolor(14)<------ (\002\002) $::gcolor(5)\#$num$::gcolor(14) ------>\017"
foreach _ [split $content \x1F] { if {$_ ne ""} {::ccs::put_msgdest $chan $_} }
putserv "PRIVMSG $chan :$::gcolor(14)=--- : $::gcolor(6)$rating$::gcolor(14); : $date ---="
return
}

proc regsub-eval {re string cmd} { return [subst [regsub -all $re [string map {\[ \\[ \] \\] \$ \\$ \\ \\\\} $string] "\[format %c \[$cmd\]\]"]] }

proc webstrip {t} {
set t [string map -nocase {{&mdash;} {-} {&raquo;} {} {&laquo;} {} {&quot;} {"}  \
		{&lt;} {<} {&gt;} {>} {&nbsp;} { } {&amp;} {&} {&copy;} {} {&#169;} {} {&bull;} {} {&#183;} {-} {&sect;} {} {&reg;} {} \
		&#8214;    || \
		&#38;      &     &#91;      (     &#92;      /     &#93;      )      &#123;     (     &#125;     ) \
		&#163;          &#168;          &#169;          &#171;           &#173;          &#174;      \
		&#161;          &#191;          &#180;          &#183;           &#185;          &#187;      \
		&#188;          &#189;          &#190;          &#192;           &#193;          &#194;      \
		&#195;          &#196;          &#197;          &#198;           &#199;          &#200;      \
		&#201;          &#202;          &#203;          &#204;           &#205;          &#206;      \
		&#207;          &#208;          &#209;          &#210;           &#211;          &#212;      \
		&#213;          &#214;          &#215;          &#216;           &#217;          &#218;      \
		&#219;          &#220;          &#221;          &#222;           &#223;          &#224;      \
		&#225;          &#226;          &#227;          &#228;           &#229;          &#230;      \
		&#231;          &#232;          &#233;          &#234;           &#235;          &#236;      \
		&#237;          &#238;          &#239;          &#240;           &#241;          &#242;      \
		&#243;          &#244;          &#245;          &#246;           &#247;          &#248;      \
		&#249;          &#250;          &#251;          &#252;           &#253;          &#254;      \
		&#176;          &#8231;         &#716;     .     &#363;     u      &#299;     i     &#712;     ' \
		&#596;     o     &#618;     i     &apos;     ' } $t]
set t [string map -nocase {&iexcl;    \xA1  &curren;   \xA4  &cent;     \xA2  &pound;    \xA3   &yen;      \xA5  &brvbar;   \xA6 \
		&sect;     \xA7  &uml;      \xA8  &copy;     \xA9  &ordf;     \xAA   &laquo;    \xAB  &not;      \xAC \
		&shy;      \xAD  &reg;      \xAE  &macr;     \xAF  &deg;      \xB0   &plusmn;   \xB1  &sup2;     \xB2 \
		&sup3;     \xB3  &acute;    \xB4  &micro;    \xB5  &para;     \xB6   &middot;   \xB7  &cedil;    \xB8 \
		&sup1;     \xB9  &ordm;     \xBA  &raquo;    \xBB  &frac14;   \xBC   &frac12;   \xBD  &frac34;   \xBE \
		&iquest;   \xBF  &times;    \xD7  &divide;   \xF7  &Agrave;   \xC0   &Aacute;   \xC1  &Acirc;    \xC2 \
		&Atilde;   \xC3  &Auml;     \xC4  &Aring;    \xC5  &AElig;    \xC6   &Ccedil;   \xC7  &Egrave;   \xC8 \
		&Eacute;   \xC9  &Ecirc;    \xCA  &Euml;     \xCB  &Igrave;   \xCC   &Iacute;   \xCD  &Icirc;    \xCE \
		&Iuml;     \xCF  &ETH;      \xD0  &Ntilde;   \xD1  &Ograve;   \xD2   &Oacute;   \xD3  &Ocirc;    \xD4 \
		&Otilde;   \xD5  &Ouml;     \xD6  &Oslash;   \xD8  &Ugrave;   \xD9   &Uacute;   \xDA  &Ucirc;    \xDB \
		&Uuml;     \xDC  &Yacute;   \xDD  &THORN;    \xDE  &szlig;    \xDF   &agrave;   \xE0  &aacute;   \xE1 \
		&acirc;    \xE2  &atilde;   \xE3  &auml;     \xE4  &aring;    \xE5   &aelig;    \xE6  &ccedil;   \xE7 \
		&egrave;   \xE8  &eacute;   \xE9  &ecirc;    \xEA  &euml;     \xEB   &igrave;   \xEC  &iacute;   \xED \
		&icirc;    \xEE  &iuml;     \xEF  &eth;      \xF0  &ntilde;   \xF1   &ograve;   \xF2  &oacute;   \xF3 \
		&ocirc;    \xF4  &otilde;   \xF5  &ouml;     \xF6  &oslash;   \xF8   &ugrave;   \xF9  &uacute;   \xFA \
		&ucirc;    \xFB  &uuml;     \xFC  &yacute;   \xFD  &thorn;    \xFE   &yuml;     \xFF} $t]
set t [regsub-eval {&#([0-9]{1,5});} $t {string trimleft \1 "0"}]
regsub -all {[\x20\x09]+} $t " " t
return $t
}

proc duration {seconds} {
	set years [expr {$seconds / 31449600}]
	set seconds [expr {$seconds % 31449600}]
	set weeks [expr {$seconds / 604800}]
	set seconds [expr {$seconds % 604800}]
	set days [expr {$seconds / 86400}]
	set seconds [expr {$seconds % 86400}]
	set hours [expr {$seconds / 3600}]
	set seconds [expr {$seconds % 3600}]
	set minutes [expr {$seconds / 60}]
	set seconds [expr {$seconds % 60}]
	set res ""
	if {$years != 0} {lappend res [numgrp $years "" "" ""]}
	if {$weeks != 0} {lappend res [numgrp $weeks "" "" ""]}
	if {$days != 0} {lappend res [numgrp $days "" "" ""]}
	if {$hours != 0} {lappend res [numgrp $hours "" "" ""]}
	if {$minutes != 0} {lappend res [numgrp $minutes "" "" ""]}
	if {$seconds != 0} {lappend res [numgrp $seconds "" "" ""]}
	return [join $res ", "]
}
proc numgrp {val str1 str2 str3} {
global dv
	set d1 [expr $val % 10]
	set d2 [expr $val % 100]
	if {$d2 < 10 || $d2 > 19} {
	if {$d1 == 1} {return "$val $str2"}
	if {$d1 >= 2 && $d1 <= 4} {return "$val $str3"}
	}
	return "$val $str1"
}
}

if {![info exists ::ccs::version]} {die "!!! Not Found CCS.tcl !!!"}