####################################################
# Windrop  Vladislav 
# : Kreon mod Vladislav
# : 1.6
# :    .
# : !
####################################################

set birthday(base) "data/birthday.txt"

setudef flag nobirthday

bind pub - $::gprefix(1) pub:birthday
bind msg - $::gprefix(1) msg:birthday
bind join - * join:birthday

if {![file exists $birthday(base)]} {
set birthday(db) ""
} else {
set fileio [open $birthday(base) r]
set lines ""
while {![eof $fileio]} {
set line [string range [set t [gets $fileio]] 0 [expr [string length $t] - 4]]
if {$line != ""} { set lines [linsert $lines end $line] }
}
close $fileio
set birthday(db) $lines
}

proc str {number} { switch -glob -- "$number" { *11 {return 3} *12 {return 3} *13 {return 3} *14 {return 3} *1 {return 1} *2 {return 2} *3 {return 2} *4 {return 2} default {return 3} } }

proc pub:birthday {nick uhost hand chan text} {
global lastbind
if {[channel get $chan nobirthday]} { return 0 }
if {([lindex $text 0]=="") || ([lindex $text 0]=="")} {
birthday:help $nick $hand "notice" $lastbind
}
if {[lindex $text 0]=="+"} {
if {[llength $text] < 5} { birthday:syntax $nick "notice"; return }
birthday:add $nick "notice" [lindex $text 1] [lindex $text 2] [lindex $text 3] [lrange $text 4 end]
}
if {[lindex $text 0]==""} { birthday:list $nick "notice" }
if {[lindex $text 0]=="-"} { birthday:del $nick $hand "notice" [lindex $text 1] }
}

proc msg:birthday {nick uhost hand text} {
global lastbind
if {([lindex $text 0]=="") || ([lindex $text 0]=="")} {
birthday:help $nick $hand "privmsg" $lastbind; return
}
if {[lindex $text 0]=="+"} {
if {[llength $text] < 5} { birthday:syntax $nick "privmsg"; return }
birthday:add $nick "privmsg" [lindex $text 1] [lindex $text 2] [lindex $text 3] [lrange $text 4 end]
}
if {[lindex $text 0]==""} { birthday:list $nick "privmsg" }
if {[lindex $text 0]=="-"} { birthday:del $nick $hand "privmsg" [lindex $text 1] }
}

proc birthday:syntax {nick type} { putserv "$type $nick :: ! +    " }

proc birthday:help {nick hand type bind} {
global birthday
putserv "$type $nick :$::gcolor(5)\037   \037:"
putserv "$type $nick :$::gcolor(6)${bind} + $::gcolor(14)<$::gcolor(6) $::gcolor(14)(01-31)> <$::gcolor(6)$::gcolor(14) (01-12)> <$::gcolor(6)$::gcolor(14) (1950-2010)> <$::gcolor(6)$::gcolor(14) ($nick)> -   ."
putserv "$type $nick :$::gcolor(6)${bind}  $::gcolor(14)-  ."
if {[matchattr $hand n]} {putserv "$type $nick :$::gcolor(6)${bind} - $::gcolor(14)<$::gcolor(6)$::gcolor(14)> -   ."}
}

proc birthday:add {nick type day month year birthman} {
global birthday
regexp {0(\d{1})} $day garb day
regexp {0(\d{1})} $month garb month
if {![string is integer $day] || ![string is integer $month] || ![string is integer $year]} { putserv "$type $nick :,        "; return }
if {$day<1 || $day>31 || $month<1 || $month>12 || ![regexp {\d{4}} $year] || [string length $year] != 4} { putserv "$type $nick :,        "; return }
if {[string length $day] == 1} {set day "0$day"}
if {[string length $month] == 1} {set month "0$month"}
set num 0
foreach line $birthday(db) {
incr num
if {[string match -nocase [string map {" " "_"} $birthman] [lindex $line 3]]}  {putserv "$type $nick :     !"; return }
}
lappend birthday(db) "$day $month $year [string map {" " "_"} [join $birthman]]"
putserv "$type $nick :[string map {" " "_"} [join $birthman]] -   !"
writedata $birthday(db)
}

proc birthday:list {nick type} {
global birthday
set i 0
if {[llength $birthday(db)] == 0} {putserv "$type $nick :  ."; return}
foreach line $birthday(db) {
incr i
lappend out "$::gcolor(4)${i}.$::gcolor(14) [lrange ${line} 0 0].[lrange ${line} 1 1].[lrange ${line} 2 2] -$::gcolor(5) [join [lrange ${line} 3 3]]"
}
::ccs::put_msgdest -type notice $nick [join $out " "]
}

proc birthday:del {nick hand type number} {
global birthday
if {![matchattr $hand n]} {putserv "$type $nick :,         +n."; return}
if {$number == ""} {putserv "$type $nick : !"; return}
if {![regexp -nocase -- {^([0-9]{1,5})$} $number]} {putserv "$type $nick : ."; return}
if {$number < 1} {putserv "$type $nick :    !"; return}
if {[llength $birthday(db)] < $number} {putserv "$type $nick :  \002 ${number}\002  !"; return}
putserv "$type $nick :   \002 ${number}\002: [lindex $birthday(db) [set number [expr $number -1]]]"
set birthday(db) [lreplace $birthday(db) $number $number]
writedata $birthday(db)
}

proc writedata {data} {
global birthday
set fileio [open $birthday(base) w]
foreach line $data {
puts $fileio "$line fs"
}
flush $fileio
close $fileio
}

proc join:birthday {nick uhost hand chan} {
global birthday
if {[channel get $chan nobirthday]} {return 0}
array set bday ""
set utime [ctime [unixtime]]
set year [lindex $utime 4]
foreach line $birthday(db) {
if {[clock format [unixtime] -format "%d %m"] == [lrange $line 0 1]} {
if {[lindex $line 2]!="no"} {set vozr " $::gcolor(14)($::gcolor(6)[set t [expr $year - [lindex $line 2]]] [lindex {.   } [str $t]]$::gcolor(14))"} else {set vozr ""}
lappend bday(today) "[join [lrange $line 3 end]]$vozr"
} elseif {[clock format [clock scan tomorrow] -format "%d %m"] == [lrange $line 0 1]} {
if {[lindex $line 2]!="no"} {set vozr " $::gcolor(14)($::gcolor(6)[set t [expr $year - [lindex $line 2]]] [lindex {.   } [str $t]]$::gcolor(14))"} else {set vozr ""}
lappend bday(tomorrow) "[join [lrange $line 3 end]]$vozr"
} elseif {[clock format [clock scan "2 days"] -format "%d %m"] == [lrange $line 0 1]} {
if {[lindex $line 2]!="no"} {set vozr " $::gcolor(14)($::gcolor(6)[set t [expr $year - [lindex $line 2]]] [lindex {.   } [str $t]]$::gcolor(14))"} else {set vozr ""}
lappend bday(ttomorrow) "[join [lrange $line 3 end]]$vozr"
} elseif {[clock format [clock scan yesterday] -format "%d %m"] == [lrange $line 0 1]} {
if {[lindex $line 2]!="no"} {set vozr " $::gcolor(14)($::gcolor(6)[set t [expr $year - [lindex $line 2]]] [lindex {.   } [str $t]]$::gcolor(14))"} else {set vozr ""}
lappend bday(prev) "[join [lrange $line 3 end]]$vozr"
}
}
if {[info exists bday(today)]} { putserv "notice $nick :$::gcolor(14)       $::gcolor(5) [join $bday(today) "$::gcolor(14),$::gcolor(5) "]" }
set out ""
if {[info exists bday(tomorrow)]} { append out "$::gcolor(14)   $::gcolor(5) [join $bday(tomorrow) "$::gcolor(14),$::gcolor(5) "]" }
if {[info exists bday(ttomorrow)]} { if {$out == ""} { append out "$::gcolor(14)    " } else { append out "$::gcolor(14),  - " }
append out "$::gcolor(5)[join $bday(ttomorrow) "$::gcolor(14),$::gcolor(5) "]" }
if {[info exists bday(prev)]} { if {$out == ""} { append out "$::gcolor(14)     " } else { append out "$::gcolor(14),       " }
append out "$::gcolor(5)[join $bday(prev) "$::gcolor(14),$::gcolor(5) "]" }
::ccs::put_msgdest -type notice $nick $out
}

if {![info exists ::ccs::version]} {die "!!! Not Found CCS.tcl !!!"}