######################################################
# Windrop  Vladislav 
# : anaesthesia
# : 01.01
# :   .
# : !
######################################################

namespace eval ircsearch {

#----------------------------------------------------------------------------
#    (Suzi / http.tcl)
#----------------------------------------------------------------------------
	#    , ,   
	variable author			"anaesthesia"
	variable version		      "01.01"
	variable date			"10-jul-2008"

	#     
	variable unamespace		[namespace tail [namespace current]]

	#     (   )
	variable pubprefix 		$::gprefix(1)
	variable pubflag		      {-|-}

	# pubcmd:_ "1 2 ..."
	#     ,      
	variable pub:ircsearch		"$unamespace irc "

	#    ,   
	variable msgprefix		$::gprefix(1)
	variable msgflag		      {-|-}
	#       
	variable msg:ircsearch		${pub:ircsearch}

	#      ,      
	#     variable [pub|msg]:handler "string ..."

	#      
	#  $unick, $uhost, $uchan
	#  tcl ,    id 
	#  .
	variable requserid		{$uhost}
	
	#        id
	variable maxreqperuser	      5

	#     
	variable maxrequests	      15

	#   ,       , 
	#  
	variable pause			15
	
	#  -
	#   "proxyhost.dom:proxyport"   ,  -
	#  
	variable proxy 			{}

	#   ,   "" --  
	# ,         --  
	#  "no"        
	#         
	# (      ,     )
	variable flagactas		"no"
	
	#   ,   /   
	#          
	#        
	#      

	variable chflag			"$flagactas$unamespace"
	setudef  flag 			$chflag

#----------------------------------------------------------------------------
#   
#----------------------------------------------------------------------------
	#    --     
	#     
	variable logrequests	{'$unick', '$uhost', '$handle', '$uchan', '$ustr'}
	
	#     ,   --  
	#  $uchan & $unick
	variable pubsend		{PRIVMSG $uchan :}

	#     ,   --  
	#   $unick ($uchan == $unick)
	variable msgsend		{PRIVMSG $unick :}
	
	#    / 
	#  $unick
	variable errsend		{NOTICE $unick :}

	#      
	variable maxredir		1
	
	#    ,   30 
	variable timeout		30000

	#    
	variable err_ok		{  }

	#     ,     
	#       
	variable err_fail		{     .      -.}

	#     

	variable err_queue_full	{           .   .}
	
	#       id
	variable err_queue_id	{    .}
	
	#          
	#   $timewait --  ,   
	#   
	variable err_queue_time {   .       $timewait .}
	
#----------------------------------------------------------------------------
#     
#----------------------------------------------------------------------------
	# ,     
	variable 		fetchurl		"http://searchirc.com/"

	#   
	variable maxres	1

	#  
	variable 		reqqueue
	array unset 	reqqueue

	#  
	variable 		laststamp
	array unset		laststamp 
	variable 		cityid
	array unset		cityid 
	variable		updinprogress	0
	variable		updatetimeout	60000

#---body---

	proc tolow {strr} { return [string tolower [string map {                                                                 } $strr]] }

	proc sspace {strr} { return [string trim [regsub -all {[\t\s]+} $strr { }]] }

	proc msg:ircsearch { unick uhost handle str } {
	pub:ircsearch $unick $uhost $handle $unick $str
	return
	}

	proc pub:ircsearch { unick uhost handle uchan str } {
	variable requserid
	variable fetchurl
	variable chflag
	variable flagactas
	variable errsend
	variable mpage		
	variable mstr
	variable idx		
	variable maxres
	variable pubprefix
	variable pubsend
	variable msgsend
	variable unamespace
	variable stype
	set id     [subst -nocommands $requserid]
	set prefix [subst -nocommands $errsend]
      if { $unick ne $uchan } { if { ![channel get $uchan $chflag] ^ $flagactas eq "no" } { return } }
	set why  [queue_isfreefor $id]
	if { $why != "" } {
	lput puthelp $why $prefix
	return
	}

#---
	if {[regexp -nocase -- {^-(\d+)} $str -> mpg]} {set mpage $mpg ; regsub -- {-\d+\s+} $str "" str} {set mpage 1}
	set mstr [expr {($mpage / 10) + 1}]
	set idx [expr {($mpage % 10) > 0 ? ($mpage % 10) : 10}]
	set ustr $str
	if {$ustr == ""} {
			if { $uchan eq $unick } {set prefix [subst -nocommands $msgsend]} {set prefix [subst -nocommands $errsend]}
			lput puthelp ": $::gprefix(1) \[- \] \[+\]<#> <irc-> " $prefix
			lput puthelp " irc-.  \002+\002# -     \037\037 .  #  ,    irc-." $prefix		
			return		
	} elseif {[regexp -nocase -- {#(.*?)(?:\s|$)(.*?)$} $ustr -> schan snet]} {
			if {$snet == ""} {set snet "all"}
			if {[string match -nocase "*rusnet*" $snet]} {set schan [encoding convertfrom cp1251 [encoding convertto koi8-r $schan]]}
			if {$mstr > 0} {set p "&P=$mstr"} {set p ""}	
			if {[regexp -- {\+} $ustr]} {set t "both"} {set t "chan"}
			set ustr "search.php?F=partial&I=$schan&T=$t&N=$snet&M=min&C=1&PER=10&D=plain$p&Submit=+Go+"
			set stype 0
	} else {
			set ustr "network/$ustr"
			set stype 1
	}
	variable logrequests
	if { $logrequests ne "" } {
			set logstr [subst -nocommands $logrequests]
			variable unamespace
			lput putlog $logstr "$unamespace: "
	}
	::http::config -useragent "Mozilla/4.0 (compatible; MSIE 4.01; Windows CE; PPC; 240x320)"	
	if { [queue_add "$fetchurl$ustr" $id "[namespace current]::dream:parser" [list $unick $uhost $uchan {}]] } {
	variable err_ok
	if { $err_ok ne "" } {
	lput puthelp "$err_ok." $prefix
	}
	} else {
	variable err_fail
	if { $err_fail ne "" } {
	lput puthelp $err_fail $prefix
	}
	}
	return
	}
#---parser
	proc dream:parser { errid errstr body extra } {
	upvar $errid lerrid $errstr lerrstr $body lbody $extra lextra
		variable err_fail
		variable pubsend
		variable msgsend
		variable errsend
		variable useurl
		variable maxres
		variable mpage
		variable mstr
		variable idx
		variable stype 
		foreach { unick uhost uchan ustr } $lextra { break }
		if { $lerrid ne {ok} } {
		lput putserv [subst -nocommands $err_fail] [subst -nocommands $errsend]
		return
		}
		if { $uchan eq $unick } {
		set prefix [subst -nocommands $msgsend]
		} else {
		set prefix [subst -nocommands $pubsend]
		}
#--suzi-patch
	global sp_version
	if {[info exists sp_version]} {	
	set str [encoding convertfrom cp1251 $lbody] 
	} else {
	set str $lbody
	}

#----------------------------------------------------------------------------
##---parser-specific------
#----------------------------------------------------------------------------
	if {$stype} {
	regsub -all -- "\n|\r|\t" $str {} str
	regsub -all -nocase -- "<b>|</b>" $str "\002" str
	if {[regexp -nocase -- {<TABLE WIDTH=100% BORDER=0 CELLSPACING=0 CELLPADDING=6><TR><TD>(.*?)</TD></TR></TABLE>} $str -> topc]} {
	regsub -all -nocase -- "<br>" $topc { - } topc
	regsub -all -nocase -- "<.*?>" $topc { } topc
	} else { set topc "N/A" }
	if {![regexp -nocase -- {<td width="70\%"><div align="center">(.*?)</div></td>} $str -> cstat]} {
	set cstat "N/A"
	} {
	regsub -all -nocase -- "&nbsp;" $cstat { } cstat
	regsub -all -nocase -- "<.*?>" $cstat { } cstat
	}
	if {[regexp -nocase -- {<td width="26\%" valign="top" nowrap>(.*?)<table width="100\%" border="0" cellspacing="3" cellpadding="3">} $str -> ninf]} {
	regsub -all -nocase -- "</tr>" $ninf { - } ninf
	regsub -all -nocase -- "&nbsp;" $ninf { } ninf
	regsub -all -nocase -- "<.*?>" $ninf { } ninf
	} else { set ninf "N/A" }
	lput putserv "$::gcolor(5)[sspace $cstat]$::gcolor(6) ::$::gcolor(14) [sspace $ninf] $::gcolor(5)[string trimright [sspace $topc] "-"]" $prefix	
	} else {
	if {![regexp -nocase -- {<td valign="top"><font size="2">.*?\(of (.*?)\)} $str -> cnum]} {
	set cnum 0
	}
	regsub -all -- "\n|\r|\t" $str {} str
	regsub -all -- {<IMG WIDTH="1" HEIGHT="10" SRC="/img/b.gif">} $str "\n" str
	regsub -all -nocase -- "<b>|</b>" $str "\002" str
	set cnt 0
	foreach line [split $str \n] {
	if {[regexp -nocase -- {<td><div align="right">Current: (.*?), Avg: (.*?), Max: (.*?)</div>.*?<a.*?HREF="/network/.*?>(.*?)</a>.*?<a.*?href="javascript.*?>(.*?)</a>.*?<td>(.*?)</td>} $line -> lnumc lnuma lnumm lnet ldesc linf]} {
      regsub -all -nocase -- "&nbsp;" $linf { } linf
	regsub -all -nocase -- "</table>" $linf { :: } linf
	regsub -all -nocase -- "<.*?>" $linf {} linf
      regsub -all -nocase -- "" $linf {} linf
	incr cnt
	}
	if {$cnt == $idx} {
	set linf [string map {"Review: There are no reviews of this channel" ""} [sconv [sspace $linf]]]
	if {[string match -nocase "*rusnet*" $lnet]} {set linf [encoding convertfrom koi8-r [encoding convertto cp1251 $linf]]}
	lput putserv "$::gcolor(14)\[$cnum\] ::$::gcolor(5) $lnet$::gcolor(14) :: :$::gcolor(6) $lnumc$::gcolor(14) :$::gcolor(6) $lnuma$::gcolor(14) :$::gcolor(6) $lnumm$::gcolor(14) :\017 [sspace $linf]" $prefix
	break
	}
	}
	if {$cnt == 0} {lput putserv "  ." $prefix}
	}
      return
      }		
#----------------------------------------------------------------------------
##---ok------
#----------------------------------------------------------------------------
	proc sconv {text} {
	set escapes {
        &nbsp; \x20 &quot; \x22 &amp; \x26 &apos; \x27 &ndash; \x2D
        &lt; \x3C &gt; \x3E &tilde; \x7E &euro; \x80 &iexcl; \xA1
        &cent; \xA2 &pound; \xA3 &curren; \xA4 &yen; \xA5 &brvbar; \xA6
        &sect; \xA7 &uml; \xA8 &copy; \xA9 &ordf; \xAA &laquo; \xAB
        &not; \xAC &shy; \xAD &reg; \xAE &hibar; \xAF &deg; \xB0
        &plusmn; \xB1 &sup2; \xB2 &sup3; \xB3 &acute; \xB4 &micro; \xB5
        &para; \xB6 &middot; \xB7 &cedil; \xB8 &sup1; \xB9 &ordm; \xBA
        &raquo; \xBB &frac14; \xBC &frac12; \xBD &frac34; \xBE &iquest; \xBF
        &Agrave; \xC0 &Aacute; \xC1 &Acirc; \xC2 &Atilde; \xC3 &Auml; \xC4
        &Aring; \xC5 &AElig; \xC6 &Ccedil; \xC7 &Egrave; \xC8 &Eacute; \xC9
        &Ecirc; \xCA &Euml; \xCB &Igrave; \xCC &Iacute; \xCD &Icirc; \xCE
        &Iuml; \xCF &ETH; \xD0 &Ntilde; \xD1 &Ograve; \xD2 &Oacute; \xD3
        &Ocirc; \xD4 &Otilde; \xD5 &Ouml; \xD6 &times; \xD7 &Oslash; \xD8
        &Ugrave; \xD9 &Uacute; \xDA &Ucirc; \xDB &Uuml; \xDC &Yacute; \xDD
        &THORN; \xDE &szlig; \xDF &agrave; \xE0 &aacute; \xE1 &acirc; \xE2
        &atilde; \xE3 &auml; \xE4 &aring; \xE5 &aelig; \xE6 &ccedil; \xE7
        &egrave; \xE8 &eacute; \xE9 &ecirc; \xEA &euml; \xEB &igrave; \xEC
        &iacute; \xED &icirc; \xEE &iuml; \xEF &eth; \xF0 &ntilde; \xF1
        &ograve; \xF2 &oacute; \xF3 &ocirc; \xF4 &otilde; \xF5 &ouml; \xF6
        &divide; \xF7 &oslash; \xF8 &ugrave; \xF9 &uacute; \xFA &ucirc; \xFB
        &uuml; \xFC &yacute; \xFD &thorn; \xFE &yuml; \xFF
	  };
	  set text [string map $escapes [join [lrange [split $text] 0 end]]]; 
        regsub -all -- {\[} $text "\\\[" text
        regsub -all -- {\]} $text "\\\]" text
        regsub -all -- {\(} $text "\\\(" text
        regsub -all -- {\)} $text "\\\)" text
  	regsub -all -- {&#([[:digit:]]{1,5});} $text {[format %c [string trimleft "\1" "0"]]} text
 	regsub -all -- {&#x([[:xdigit:]]{1,4});} $text {[format %c [scan "\1" %x]]} text
 	regsub -all -- {&#?[[:alnum:]]{2,7};} $text "" text
	return [subst -novariables $text]
	}

#--        
proc lput { cmd str { prefix {} } {maxchunk 420} } {
set buf1 ""; set buf2 [list];
foreach word [split $str] {
append buf1 " " $word;
if {[string length $buf1]-1 >= $maxchunk} {
lappend buf2 [string range $buf1 1 end];
set buf1 "";
}
}
if {$buf1 != ""} {
lappend buf2 [string range $buf1 1 end];
}
foreach line $buf2 {		
$cmd $prefix$line 
}
return
}

#---queue
proc queue_isfreefor { { id {} } } {
variable reqqueue
variable maxreqperuser
variable maxrequests
variable laststamp
variable pause
variable err_queue_full	
variable err_queue_id
variable err_queue_time 
if { [info exists laststamp(stamp,$id)] } {
set timewait [expr { $laststamp(stamp,$id) + $pause - [unixtime]}]
if { $timewait > 0 } {
return [subst -nocommands $err_queue_time]
}			
}
if { [llength [array names reqqueue -glob "*,$id"]] >= $maxreqperuser } {
return $err_queue_id
}
if { [llength [array names reqqueue]] >= $maxrequests } { 
return $err_queue_full
}
return
}

#---add-to-queue
proc queue_add { newurl id parser extra {redir 0} } {
variable reqqueue
variable proxy
variable timeout
variable laststamp
::http::config -proxyfilter "[namespace current]::queue_proxy"
if { ! [catch {
set token [::http::geturl $newurl -command "[namespace current]::queue_done" -binary true -timeout $timeout]
} errid] } {
set reqqueue($token,$id) [list $parser $extra $redir]		
set laststamp(stamp,$id) [unixtime]
} else {
return false
}
return true
}

#---proxy
proc queue_proxy { url } {
variable proxy
if { $proxy ne {} } { return [split $proxy {:}] }		
return [list]
}
	
#---callback
proc queue_done { token } {
upvar #0 $token state
variable reqqueue
variable maxredir	
set errid  		[::http::status $token]
set errstr 		[::http::error  $token]
set	id  	[array  names reqqueue "$token,*"]
foreach { parser extra redir } $reqqueue($id) { break }
regsub -- "^$token," $id {} id
while (1) {
if { $errid == "ok" && [::http::ncode $token] == 302 } {
if { $redir < $maxredir } {			
array set meta $state(meta)
if { [info exists meta(Location)] } {
variable fetchurl
queue_add "$fetchurl$meta(Location)" $id $parser $extra [incr redir]
break
}
} else {
set errid   "error"
set errstr  "Maximum redirects reached"
}
} 
if { [catch { $parser {errid} {errstr} {state(body)} {extra} } errid ] } {
lput putlog $errid "[namespace current] "
}
break
}	
array unset reqqueue "$token,*"
::http::cleanup $token
return
}

#---clear
proc queue_clear_stamps {} {
variable laststamp
variable timeout
variable timerID
set curr [expr { [unixtime] - 2 * $timeout / 1000 }];
foreach { id } [array names laststamp] {
if { $laststamp($id) < $curr } {
array unset laststamp $id;
}
}		
set timerID [timer 10 "[info level 0]"]
}

#---command aliases & bnd
proc cmdaliases { { action {bind} } } {
foreach { bindtype } {pub msg dcc} {
foreach { bindproc } [info vars "[namespace current]::${bindtype}:*"] {
variable "${bindtype}prefix"
variable "${bindtype}flag"			
foreach { alias } [set $bindproc] {
catch { $action $bindtype [set ${bindtype}flag] [set ${bindtype}prefix]$alias $bindproc }
}				
}
}
return
}
#---killtimers	
if {[info exists timerID]} {
catch {killtimer $timerID}; 
catch {unset timerID}
}
#---rest	
[namespace current]::queue_clear_stamps
cmdaliases
global sp_version
}