######################################################
# Windrop  Vladislav 
# : Stream
# : 1.2
# : !
######################################################

namespace eval peak {}

setudef flag nopeak
setudef flag auto-peak

#################################################

bind pub - $::gprefix(1)peak	::peak::pub_peak
bind pub - $::gprefix(1)	::peak::pub_peak
bind msg - $::gprefix(1)peak	::peak::msg_peak
bind msg - $::gprefix(1)	::peak::msg_peak

bind join - *	::peak::onjoin

#################################################

catch {unset peak}

# show nicks of users (not recommended on large chans)
set peak(nicks)		1
# maximum length of a message
set peak(maxlen)	      400
# announce delay to prevent flooding on massjoins (seconds)
set peak(delay)		10
# filename to store peak values
set peak(file)		"data/peak.data"

set peak(data)		""

#################################################

proc ::peak::readdata {} {
global peak
set peak(data) ""
if {![catch {set fid [open $peak(file) "r"]}]} {
while {![eof $fid]} {
set data [split [string trim [gets $fid]] " "]
if {[llength $data] > 3} {lappend peak(data) [list [lindex $data 0] [lindex $data 1] [lindex $data 2] [lrange $data 3 end]]}
}
close $fid
} else {putlog "\[peak\] can't open file '$peak(file)'!"}
}

proc ::peak::writedata {} {
global peak
set fid [open "$peak(file)" "w+"]
foreach data $peak(data) {
puts $fid "[join [lrange $data 0 2]] [join [lindex $data 3]]"
}
close $fid
}

proc ::peak::tolower {text} { return [string map {                                                                 } [string tolower $text]] }

proc ::peak::out {nick chan text} {
global peak
if {[validchan $chan]} {set cmd "PRIVMSG $chan :"
} elseif {$nick == $chan} {set cmd "PRIVMSG $nick :"
} else {set cmd "NOTICE $nick :"}
while {[string length $text] > 0} {
if {[string length $text] <= $peak(maxlen) || [llength [split $text]] == 1} {putserv "$cmd$text"; break}
set msg ""
set newtext ""
foreach word [split $text] {
if {[expr [string length $msg] + [string length $word]] <= $peak(maxlen)} {lappend msg $word
} elseif {$msg == "" && [string length $word] > $peak(maxlen)} {lappend msg $word
} else {lappend newtext $word}
}
if {$msg != ""} {putserv "$cmd[join $msg]"}
set text $newtext
}
}

proc ::peak::announce {chan text} {
global botnick
::peak::out $botnick $chan $text
}

proc ::peak::delayedannounce {chan text} {
global peak
foreach tmr [utimers] {
set cmd [split [join [lindex $tmr 1]] " "]
if {[string equal [lindex $cmd 0] "::peak::announce"] && [string equal [lindex $cmd 1] $chan]} {
killutimer [lindex $tmr 2]
}
}
utimer $peak(delay) "::peak::announce $chan \"$text\""
}

proc ::peak::init {} {
::peak::readdata
}

#################################################

proc ::peak::pub_peak {nick uhost hand chan args} {
if {[channel get $chan nopeak]} { return }
set pchan [string trim [lindex $args 0]]
if {[string length $pchan] != 0} {
if {[string range $pchan 0 0] != "#"} {::peak::out $nick $chan " $::gprefix(1) \[#\]"; return}
if {![validchan $pchan]} {::peak::out $nick $chan "     $pchan"; return}
::peak::peak $nick $chan $pchan
} else {::peak::peak $nick $chan $chan}
}

proc ::peak::msg_peak {nick uhost hand args} {
set pchan [string trim [lindex $args 0]]
if {[string range $pchan 0 0] != "#"} {::peak::out $nick $nick " $::gprefix(1) <#>."; return}
if {![validchan $pchan]} {::peak::out $nick $nick "     $pchan"; return}
::peak::peak $nick $nick $pchan
}

#################################################

proc ::peak::peak {nick chan pchan} {
global peak
foreach data $peak(data) {
if {[string equal [::peak::tolower $pchan] [lindex $data 0]]} {
set str [::peak::numstr [lindex $data 1] "$::gcolor(14)" "$::gcolor(14)" "$::gcolor(14)"]
::peak::out $nick $chan "$::gcolor(14) $::gcolor(5) $pchan$::gcolor(14):$::gcolor(6) $str$::gcolor(5) [::peak::rustimebrak [lindex $data 2]] $::gcolor(14)([::peak::duration [expr {[unixtime] - [lindex $data 2]}]] .)   -$::gcolor(6) [join [lindex [lindex $data end] end]]$::gcolor(14)."
if {$peak(nicks) == 1} {::peak::out $nick "" "  : [join [lindex $data 3]]"}
return
}
}
::peak::out $nick $chan "  $pchan  ."
}

proc ::peak::onjoin {nick uhost hand chan} {
global peak
set res ""
set oldpeak 0
set users [chanlist $chan]
set ucount [llength $users]
foreach data $peak(data) {
if {[string equal [::peak::tolower $chan] [lindex $data 0]]} {
set oldpeak [lindex $data 1]
} else {
lappend res $data
}
}
if {$oldpeak < $ucount} {
lappend res [list [::peak::tolower $chan] $ucount [unixtime] $users]
if {[channel get $chan auto-peak]} {
set str [::peak::numstr $ucount "$::gcolor(14)" "$::gcolor(14)" "$::gcolor(14)"]
::peak::delayedannounce $chan "$::gcolor(14)  $::gcolor(5) $chan$::gcolor(14):$::gcolor(6) $str$::gcolor(14)."
}
set peak(data) $res
::peak::writedata
}
}

proc ::peak::duration {seconds} {
	set years [expr {$seconds / 31449600}]
	set seconds [expr {$seconds % 31449600}]
	set weeks [expr {$seconds / 604800}]
	set seconds [expr {$seconds % 604800}]
	set days [expr {$seconds / 86400}]
	set seconds [expr {$seconds % 86400}]
	set hours [expr {$seconds / 3600}]
	set seconds [expr {$seconds % 3600}]
	set minutes [expr {$seconds / 60}]
	set seconds [expr {$seconds % 60}]
	set res ""
	if {$years != 0} {lappend res [::peak::numstr $years "" "" ""]}
	if {$weeks != 0} {lappend res [::peak::numstr $weeks "" "" ""]}
	if {$days != 0} {lappend res [::peak::numstr $days "" "" ""]}
	if {$hours != 0} {lappend res [::peak::numstr $hours "" "" ""]}
	if {$minutes != 0} {lappend res [::peak::numstr $minutes "" "" ""]}
	if {$seconds != 0} {lappend res [::peak::numstr $seconds "" "" ""]}
	return [join $res ", "]
}

proc ::peak::numstr {val str1 str2 str3} {
set d1 [expr $val % 10]
set d2 [expr $val % 100]
if {$d2 < 10 || $d2 > 19} {
if {$d1 == 1} {return "$val $str2"}
if {$d1 >= 2 && $d1 <= 4} {return "$val $str3"}
}
return "$val $str1"
}

proc ::peak::rustimebrak {seconds} {
if {$seconds ne ""} {
return [clock format $seconds -format "%d.%m.%Y"]
}
}
::peak::init