######################################################
# Windrop  Vladislav 
# : Stream mod Vladislav
# : 1.4
# :   .									
# :	      !addquote <> -    ;			
#			!delquote <> -     ;	
#			!quote -   ;						
#			!quote <> -     			
#			!quote <> -  ,     ""								      
#####################################################################################

namespace eval quote {}

setudef flag noquote
setudef flag auto-quote

#################################################

bind pub	-	$::gprefix(1)quote	::quote::pub_quote
bind pub	-	$::gprefix(1)	::quote::pub_quote
bind pub	-	$::gprefix(1)q		::quote::pub_quote
bind pub	-	$::gprefix(1)		::quote::pub_quote
bind pub	-	$::gprefix(1)addquote	::quote::pub_addquote
bind pub	-	$::gprefix(1)+	::quote::pub_addquote
bind pub	-	$::gprefix(1)aq		::quote::pub_addquote
bind pub	-	$::gprefix(1)+		::quote::pub_addquote
bind pub	o|o	$::gprefix(1)delquote	::quote::pub_delquote
bind pub	o|o	$::gprefix(1)-	::quote::pub_delquote
bind pub	o|o	$::gprefix(1)dq		::quote::pub_delquote
bind pub	o|o	$::gprefix(1)-		::quote::pub_delquote

#################################################

foreach p [array names quote *] {catch {unset quote($p)}}

#################################################

set quote(announcetime)	45
set quote(datafile)	"data/quote.data"
set quote(data)		""

#################################################

proc ::quote::readdata {} {
	global quote
	set quote(data) ""
	if {![catch {set fid [open $quote(datafile) "r"]}]} {
	while {![eof $fid]} {
      set data [split [string trim [gets $fid]] "|"]
	if {[llength $data] == 4} {lappend quote(data) $data}
	}
	close $fid
	} 
}

proc ::quote::writedata {} {
	global quote
	set fid [open "$quote(datafile)" "w+"]
	foreach data $quote(data) {
	set sdata [join $data "|"]
	puts $fid "$sdata  "
	}
	close $fid
}

proc ::quote::init {} {
	global quote
	foreach tmr [timers] {if {[lindex $tmr 1] == "::quote::announce"} {killtimer [lindex $tmr 2]}}
	::quote::readdata
	timer $quote(announcetime) ::quote::announce
}

proc ::quote::tolower {text} {
	return [string map {                                                                 } [string tolower $text]]
}

proc ::quote::out {nick chan text} {
	global botnick
	if {$nick != $botnick} {
	if {[validchan $chan]} {putserv "PRIVMSG $chan :$text"
	} else {putserv "NOTICE $nick :$text"}
	} else {putserv "PRIVMSG $chan :$text"}
}

#################################################

proc ::quote::pub_quote {nick uhost hand chan args} {
	if {![validchan $chan]} {return}
      if {[channel get $chan noquote]} { return }
	regsub -all -- {\\} [join $args] "" args
	::quote::quote $nick $uhost $hand $chan $chan [string trim $args]
}

proc ::quote::pub_addquote {nick uhost hand chan args} {
	if {![validchan $chan]} {return}
	if {[channel get $chan noquote]} { return }
	regsub -all -- {\\} [join $args] "" args
	::quote::addquote $nick $uhost $hand $chan [string trim $args]
}

proc ::quote::pub_delquote {nick uhost hand chan args} {
	if {![validchan $chan]} {return}
	if {[channel get $chan noquote]} { return }
	regsub -all -- {\\} [join $args] "" args
	::quote::delquote $nick $uhost $hand $chan [string trim $args]
}

#################################################

proc ::quote::total {chan} {
	global quote
	set total 0
	foreach q $quote(data) {if {![validchan $chan] || [string equal [lindex $q 0] $chan]} {incr total}}
	return $total
}

proc ::quote::addquote {nick uhost hand chan args} {
	global quote
	set args [join $args]
	if {[string length $args] < 1} {::quote::out $nick $nick ": $::gprefix(1)+ <>"; return}
	set largs [::quote::tolower $args]
	set num 0
	foreach q $quote(data) {
		if {![string equal [lindex $q 0] $chan]} {continue}
		incr num
		if {[string equal [::quote::tolower [lindex $q 2]] $largs]} {
		::quote::out $nick $nick "    ( $num)."
		return
		}
	}
	lappend quote(data) [list $chan $nick $args [unixtime]]
	incr num
	::quote::out $nick $nick "  ( $num)."
	::quote::writedata
}

proc ::quote::delquote {nick uhost hand chan args} {
	global quote
	set args [join $args]
	if {[string length $args] < 1} {::quote::out $nick $nick ": $::gprefix(1)- <>"; return}
	if {[::quote::total $chan] == 0} {::quote::out $nick $nick "     ..."; return}
	if {![regexp -nocase -- {^([0-9]{1,5})$} $args]} {::quote::out $nick $nick "  ."; return}
	set num 0
	set res ""
	foreach q $quote(data) {
		if {![string equal [lindex $q 0] $chan]} {lappend res $q; continue}
		incr num
		if {$num != $args} {lappend res $q} else {::quote::out $nick $nick "   $num."}
	}
	if {[llength $res] < [llength $quote(data)]} {
		set quote(data) $res
		::quote::writedata
	} else {::quote::out $nick $nick "   $args  ."}
}

proc ::quote::randomquote {nick chan dchan} {
	global quote botnick
	set total [::quote::total $chan]
	if {$total == 0} {return}
	set rnum [rand $total]
	set num 0
	set res ""
	foreach q $quote(data) {
		if {[validchan $chan] && ![string equal [lindex $q 0] $chan]} {continue} 
		if {$num == $rnum} {set res $q}
		incr num
	}
	if {$res != ""} {
		if {[validchan $chan]} {::quote::out $botnick $dchan "$::gcolor(14)\[$::gcolor(6)[expr {$rnum + 1}]$::gcolor(14)/$num\]\003 [lindex $res 2]\017 $::gcolor(14)\[$::gcolor(5)[lindex $res 1]$::gcolor(14) [clock format [lindex $res 3] -format {%d-%m-%Y %H:%M:%S}]\]"
		} else {::quote::out $nick $dchan "$::gcolor(14)\[$::gcolor(6)[expr {$rnum + 1}]$::gcolor(14)/$num\]\003 [lindex $res 2]\017 $::gcolor(14)\[$::gcolor(5)[lindex $res 1]$::gcolor(14) [clock format [lindex $res 3] -format {%d-%m-%Y %H:%M:%S}]\]"}
	}
	
}

proc ::quote::quotebynum {nick chan dchan args} { 
	global quote botnick
	set args [join $args]
	set num 0
	set res ""
	foreach q $quote(data) {
		if {[validchan $chan] && ![string equal [lindex $q 0] $chan]} {continue}
		incr num
		if {$num == $args} {set res $q}
	}
	if {$res != ""} {
		if {[validchan $chan]} {::quote::out $botnick $dchan "$::gcolor(14)\[$::gcolor(6)$args$::gcolor(14)/$num\]\003 [lindex $res 2]\017 $::gcolor(14)\[$::gcolor(5)[lindex $res 1]$::gcolor(14) [clock format [lindex $res 3] -format {%d-%m-%Y %H:%M:%S}]\]"
		} else {::quote::out $nick $dchan "$::gcolor(14)\[$::gcolor(6)$args$::gcolor(14)/$num\]\003 [lindex $res 2]\017 $::gcolor(14)\[$::gcolor(5)[lindex $res 1]$::gcolor(14) [clock format [lindex $res 3] -format {%d-%m-%Y %H:%M:%S}]\]"}
	} else {::quote::out $nick $nick "   $args  ."}
}

proc ::quote::quotebycontent {nick chan dchan args} {
	global quote botnick
	set args [join $args]
	set num 0
	set res ""
	set rnum 0
	foreach q $quote(data) {
		if {[validchan $chan] && ![string equal [lindex $q 0] $chan]} {continue}
		incr num
		if {$res == ""} {
			if {[string match "*$args*" "[lindex $q 2] \[[lindex $q 1]\]"]} {
				set res $q
				set rnum $num
			}
		}
	}
	if {$res != ""} { 
		if {[validchan $chan]} {::quote::out $botnick $dchan "$::gcolor(14)\[$::gcolor(6)$rnum$::gcolor(14)/$num\]\003 [lindex $res 2]\017 $::gcolor(14)\[$::gcolor(5)[lindex $res 1]$::gcolor(14) [clock format [lindex $res 3] -format {%d-%m-%Y %H:%M:%S}]\]"
		} else {::quote::out $nick $dchan "$::gcolor(14)\[$::gcolor(6)$rnum$::gcolor(14)/$num\]\003 [lindex $res 2]\017 $::gcolor(14)\[$::gcolor(5)[lindex $res 1]$::gcolor(14) [clock format [lindex $res 3] -format {%d-%m-%Y %H:%M:%S}]\]"}
	} else {::quote::out $nick $nick "  ."}
}

proc ::quote::quote {nick uhost hand chan dchan args} {
	global quote
	if {[::quote::total $chan] == 0} {::quote::out $nick $nick "     ..."; return}
	set args [join $args]
	if {[string length $args] == 0} {::quote::randomquote $nick $chan $dchan
	} elseif {[regexp -nocase -- {^([0-9]{1,5})$} $args]} {::quote::quotebynum $nick $chan $dchan $args
	} else {::quote::quotebycontent $nick $chan $dchan $args}
}

proc ::quote::announce {} {
	global quote botnick
	if {[llength $quote(data)] == 0} {return}
	foreach chan [channels] {
		if {[channel get $chan auto-quote]} {::quote::randomquote $botnick $chan $chan}
	}
	timer $quote(announcetime) ::quote::announce
}

::quote::init
