####################################################
# Windrop  Vladislav 
# : CoolCold
# : 1.0b6
# : C  .
#    :
# *       
# *   /      
# *   ,          (+o/+m )
####################################################

namespace eval chanrule {

	#           
	set ndt_flag "+n|+m"
	
	#    
	set del_flags "+n|+m"
	
	#   
	set add_flags "+n|+m"
	
	#  /      
	set show_flags "+n|+m"
	
	#        (   )
	set listother_flags "+m|+m"
	
	#   
	set fname "data/rules.txt"
	
	#  
	set trigadd $::gprefix(1)+
	
	#  
	set trigdel $::gprefix(1)-
	
	#  
	set trigmove $::gprefix(1)
	
	#    
	set triglist $::gprefix(1)+
	
	#      on/off
	set trigshow $::gprefix(1)
	
	#    info/help 
	set triginfo $::gprefix(1)
	
	#       ?
	set usefast 1

      setudef flag norules
      setudef flag join-rules

#############################

	set chans(names) ""
	set rules(names) ""
	foreach b [array names rules *] {
    	catch {unset rules($b)}
  	}

      proc putfast {text} {
      putnow $text
      return
      }

	proc putserv { text } {
	variable usefast		
	if {$usefast=="1"} {
	putfast $text
	} else {
	::putserv $text
	}
	}
      }

proc ::chanrule::init { } {
::chanrule::loadrules
return 0
}

proc ::chanrule::loadrules { } {
variable fname;variable delimiter;variable chans;variable rules
if {[file exists $fname]} {
set fid [open $fname r ]
set c "0"
while {![eof $fid]} {
gets $fid l; if {$l == ""} {continue}
set chname "[lindex [split $l ] 0]"
set chrules [string range $l [expr [string length $chname] + 1] end]
lappend chans(names) $chname
set rules($chname) $chrules
incr c
}
close $fid
}
return 0
}

proc ::chanrule::save { } {
variable fname;variable delimiter;variable chans;variable rules
if {![file exists $fname]} {set fid [open $fname w];puts $fid "";close $fid}
if {[llength chans(names)]>0} {
set fid [open $fname "TRUNC RDWR"]
foreach {i} $chans(names) {
puts $fid "$i $rules($i)"
}
flush $fid
close $fid
}
return 0
}

proc ::chanrule::listrules { nick uhost hand chan rest } {
variable chans; variable rules; variable listother_flags
variable show_flags
global botnick
set chan [string tolower $chan]
set rest [string tolower $rest]
if {![info exists chans(names)]} {return 0}
if {$rest==""} {
set i [lsearch -exact $chans(names) $chan]
if {$i=="-1"} {
putserv "NOTICE $nick :      $chan."
} else {
set c 0
putserv "NOTICE $nick :\037   $chan\017:"
foreach j $rules($chan) {
incr c
putserv "NOTICE $nick :$::gcolor(4)$c.\003 $j"
}
}
} else {
set displayed "0"
switch -exact -- [string tolower [string range $rest 0 0]] "&" - "#" {
if {[matchattr $hand $listother_flags $rest]} {
if {[lsearch -exact $chans(names) $rest]!="-1"} {
set c 0
putserv "NOTICE $nick :\037   $rest\017:"
foreach j $rules($rest) {
incr c
putserv "NOTICE $nick :$::gcolor(4)$c.\003 $j"
}
} else {putserv "NOTICE $nick :      $rest"}
}
} default {
if {[matchattr $hand $show_flags $chan]} {
set bnick [string tolower $botnick]
set rest [lindex [split $rest ] 0]
set rest [string tolower $rest]
if {([onchan $rest $chan]) && ($rest!=$bnick)} {
if {[lsearch -exact $chans(names) $chan]!="-1"} {
set c 0
putserv "NOTICE $rest :\037      $chan\017:"
foreach j $rules($chan) {
incr c
putserv "NOTICE $rest :$::gcolor(4)$c.\003 $j"
}
} else { putserv "NOTICE $nick :     $chan,    \"$rest\" ."}
} else {
putserv "NOTICE $nick :   $chan  \"$rest\" ,   \"$rest\"             ."
}
}
}
}
return 0
}

proc ::chanrule::addrule { nick uhost hand chan rest } {
variable chans;variable rules;variable add_flags
set chan [string tolower $chan]
if {![matchattr $hand $add_flags $chan]} {return 0}
if {[channel get $chan norules]} { return }
if {$rest==""} {putserv "NOTICE $nick : , .";return 0}
set i [lsearch -exact $chans(names) $chan]
if {$i=="-1"} {
lappend chans(names) $chan
}
putserv "NOTICE $nick : \"$rest\017\"   $chan ."
lappend rules($chan) "$rest"
::chanrule::save
return 0
}

proc ::chanrule::delrule { nick uhost hand chan rest } {
variable chans;variable rules;variable del_flags
set chan [string tolower $chan]
if {![matchattr $hand $del_flags $chan]} {return 0}
if {[channel get $chan norules]} { return }
if {$rest == ""} {putserv "NOTICE $nick : !"; return}
if {![regexp -nocase -- {^([0-9]{1,5})$} $rest]} {putserv "NOTICE $nick : ."; return}
set i [lsearch -exact $chans(names) $chan]
if {$i=="-1"} {
putserv "NOTICE $nick :       $chan,   ,    ."
} else {
if {[lindex $rules($chan) [expr $rest - 1]]==""} {
putserv "NOTICE $nick :   \002$rest\002  ."
} else {
set tmprule [lindex $rules($chan) [expr $rest - 1]]
set rules($chan) [lreplace $rules($chan) [expr $rest - 1] [expr $rest - 1]]
putserv "NOTICE $nick :  #$rest   $chan ( $tmprule )"
if {[llength $rules($chan)]=="0"} {
set chans(names) [lreplace $chans(names) $i $i]
unset rules($chan)
channel set $chan -join-rules
putserv "NOTICE $nick : $chan    ."
}
::chanrule::save
}
}
return 0
}

proc ::chanrule::showrules { nick uhost hand chan rest } {
variable chans;variable rules;variable show_flags
set chan [string tolower $chan]
if {![matchattr $hand $show_flags $chan]} {return 0}
if {![info exists chans(names)] || [channel get $chan norules] || ![info exists rules($chan)]} {
putserv "NOTICE $nick : $chan     ."
return 0
}
if {$rest=="on"} {
channel set $chan +join-rules
putserv "PRIVMSG $chan :$::gcolor(14)   :$::gcolor(10) on"
} elseif {$rest=="off"} {
channel set $chan -join-rules
putserv "PRIVMSG $chan :$::gcolor(14)   :$::gcolor(4) off"
} else {
if {[channel get $chan join-rules]} {set bla "on"} else {set bla "off"}
putserv "PRIVMSG $chan :$::gcolor(14)  :$::gcolor(5) $bla"
}
return 0
}

proc ::chanrule::rulemove { nick uhost hand chan rest } {
global lastbind
variable chans;variable rules;variable del_flags;variable add_flags
set chan [string tolower $chan]
if {!([matchattr $hand $del_flags $chan] || [matchattr $hand $add_flags $chan])} {return 0}
if {[channel get $chan norules]} { return }
set i [lsearch -exact $chans(names) $chan]
if {$i=="-1"} {
putserv "NOTICE $nick :       $chan,   ,    ."
} else {
set ruleindx [lindex [split $rest " "] 0];set mvtoindx [lindex [split $rest " "] 1]
if {![isnumber $ruleindx] || ![isnumber $mvtoindx]} {putserv "NOTICE $nick :   ,   .";return 0}
if {[lindex $rules($chan) [expr $ruleindx - 1]]==""} {
putserv "NOTICE $nick :     $chan   $ruleindx"
} else {
set tmprule [lindex $rules($chan) [expr $ruleindx - 1]]
if {$mvtoindx > [llength $rules($chan)]} {
set rules($chan) [lreplace $rules($chan) [expr $ruleindx - 1] [expr $ruleindx - 1]]
lappend rules($chan) $tmprule
putserv "NOTICE $nick : \"$tmprule\"   $chan      ."
} elseif {[expr $mvtoindx - 1] <= 0} {
set rules($chan) [lreplace $rules($chan) [expr $ruleindx - 1] [expr $ruleindx - 1]]
set rules($chan) [linsert $rules($chan) 0 $tmprule]
putserv "NOTICE $nick : \"$tmprule\"   $chan      ."
} elseif {$mvtoindx == $ruleindx} {
putserv "NOTICE $nick :      \"$tmprule\"  $ruleindx  $mvtoindx?"
} else {
if {$ruleindx>$mvtoindx} {
set rules($chan) [lreplace $rules($chan) [expr $ruleindx - 1] [expr $ruleindx - 1]]
set rules($chan) [linsert $rules($chan) [expr $mvtoindx - 1] $tmprule]
putserv "NOTICE $nick : \"$tmprule\"  $ruleindx  $mvtoindx"
} else {
set rules($chan) [linsert $rules($chan) [expr $mvtoindx - 1] $tmprule]
set rules($chan) [lreplace $rules($chan) [expr $ruleindx - 1] [expr $ruleindx - 1]]
putserv "NOTICE $nick : \"$tmprule\"  $ruleindx  $mvtoindx"
}
}
::chanrule::save
}
}
}

proc ::chanrule::showinfo { nick uhost hand chan rest } {
variable del_flags;variable add_flags;variable show_flags;variable listother_flags
variable trigadd; variable trigdel; variable trigshow; variable triglist; variable trigmove
global lastbind
if {[channel get $chan norules]} { return }
set pau [lindex [split $rest " "] 0]
switch -exact [string tolower $pau] {
		"" {
			set piu 0
			append bla "$lastbind  \[\]"
			if {[matchattr $hand $del_flags $chan]} {append bla " | $lastbind - <#>";set piu 1}
			if {[matchattr $hand $add_flags $chan]} {if {$piu} {append bla " | "};append bla "$lastbind + <>";set piu 1}
			if {[matchattr $hand $show_flags $chan]} {if {$piu} {append bla " | "};append bla "$lastbind /";set piu 1}
			if {[matchattr $hand $add_flags $chan] || [matchattr $hand $del_flags $chan]} {if {$piu} {append bla " | "};append bla "$lastbind  <> <>";set piu 1}
			if {$piu=="1"} {
			putserv "NOTICE $nick :,  : $bla"
			} else {
			::chanrule::listrules $nick $uhost $hand $chan ""
			}
		}
		"" {
			set bla ""
			set bla [lindex [split $rest " "] 1]
			::chanrule::listrules $nick $uhost $hand $chan $bla
		}
		"" {
			::chanrule::showrules $nick $uhost $hand $chan "on"
		}
		"" {
			::chanrule::showrules $nick $uhost $hand $chan "off"
		}
		"-"  {
			set bla ""
			set bla [string range $rest 2 end]
			::chanrule::delrule $nick $uhost $hand $chan $bla
		}
		"+"   {
			set bla ""
			set bla [string range $rest 2 end]
			::chanrule::addrule $nick $uhost $hand $chan $bla
		}
		""	{
			set bla ""
			set bla [string range $rest 8 end]
			::chanrule::rulemove $nick $uhost $hand $chan $bla
		}
	      }
return 0
}

proc ::chanrule::onjoin { nick uhost hand chan } {
variable chans;variable rules;variable ndt_flag
global botnick
set chan [string tolower $chan]
if {![info exists chans(names)] || [channel get $chan norules]} {return 0}
if {[matchattr $hand $ndt_flag $chan] || ($nick==$botnick)} {return 0}
if {![channel get $chan join-rules]} {return 0}
set i [lsearch -exact $chans(names) $chan]
if {$i!="-1"} {
set c 0
::chanrule::listrules $nick $uhost $hand $chan ""
}
return 0
}

bind pub - "$::chanrule::trigadd" ::chanrule::addrule
bind pub - "$::chanrule::trigdel" ::chanrule::delrule
bind pub - "$::chanrule::triglist" ::chanrule::listrules
bind pub - "$::chanrule::trigshow" ::chanrule::showrules
bind pub - "$::chanrule::triginfo" ::chanrule::showinfo
bind pub - "$::chanrule::trigmove" ::chanrule::rulemove
bind join - * ::chanrule::onjoin

::chanrule::init