######################################################
# Windrop  Vladislav 
# : Vertigo
# : 3.3
# : ! !
######################################################

namespace eval ::vseen {

#     
variable base "data/vseen.dat"
#       
variable pubmbase "data/vseen_pubm.dat"
# 
variable debug 0
#       ()
variable expire 62208000; # 720 days
#    
variable maxmatches 500
#   [w/m]
variable botgender "m"

if {![file exists $base]} {set f [open $base w+]; close $f}

variable bchan {}
variable bnick {}
variable bnum 1
variable b_cache ""
variable cl_cache ""

bind join - * ::vseen::vjoin
bind part - * ::vseen::vpart
bind sign - * ::vseen::vsign
bind kick - * ::vseen::vkick
bind nick - * ::vseen::vnick
bind splt - * ::vseen::vsplt
bind rejn - * ::vseen::vrejn
bind chjn - * ::vseen::vchjn
bind chpt - * ::vseen::vchpt

bind pubm - * ::vseen::pubm
bind pub - $::gprefix(1)seen "::vseen::pub 0"
bind pub - $::gprefix(1) "::vseen::pub 0"
bind pub o|m $::gprefix(1)$::gprefix(1)seen "::vseen::pub 2"
bind pub o|m $::gprefix(1)$::gprefix(1) "::vseen::pub 2"
bind pub - $::gprefix(1)seennick "::vseen::pub 1"
bind pub - $::gprefix(1) "::vseen::pub 1"
bind pub - $::gprefix(1)seenstats ::vseen::pub_stats
bind pub - $::gprefix(1) ::vseen::pub_stats
bind time - "01 00 * * *" ::vseen::clear
bind pub n $::gprefix(1)optimizeseens "::vseen::optimize 0"

setudef flag novseen

proc pubm {nick uhost hand chan text} {
variable pubmbase
set text [string map {\017 ""} [stripcodes bcurag $text]]
if {[string is space $text]} {return}
if {![file exists $pubmbase]} {
set f [open $pubmbase w+]
if {[encoding system] ne "cp1251"} {fconfigure $f -encoding cp1251}
close $f
return
}
set f [open $pubmbase r]
if {[encoding system] ne "cp1251"} {fconfigure $f -encoding cp1251}
set data [lrange [split [read $f] \n] 0 end-1]
close $f
if {[lsearch -exact -index 0 $data "$nick|$chan"] == "-1"} {
lappend data [list "$nick|$chan" $text]
unset -nocomplain text
} elseif {[set idx [lsearch -exact -index 0 $data "$nick|$chan"]] != "-1"} {
set data [lreplace $data $idx $idx [list "$nick|$chan" $text]]
unset -nocomplain line text idx
} else {
unset -nocomplain data
return
}
set f [open $pubmbase w]
if {[encoding system] ne "cp1251"} {fconfigure $f -encoding cp1251}
puts $f [join $data \n]
close $f
}

proc pubmtext {nick chan} {
variable pubmbase
if {![file exists $pubmbase]} {
set f [open $pubmbase w+]
if {[encoding system] ne "cp1251"} {fconfigure $f -encoding cp1251}
close $f
return 0
}
set f [open $pubmbase r]
if {[encoding system] ne "cp1251"} {fconfigure $f -encoding cp1251}
set data [lrange [split [read $f] \n] 0 end-1]
close $f
if {[set idx [lsearch -exact -index 0 $data "$nick|$chan"]] != "-1"} {
return [join [lrange [lindex $data $idx] 1 end]]
} else {
return 0
}
}

proc pub_stats {nick uhost hand chan text} {
if {[validuser $hand] && [matchattr $hand X]} {
putserv "NOTICE $nick :Access denied."
return
}
if {[channel get $chan novseen]} { return }
variable base
set f [open $base r]
if {[encoding system] ne "cp1251"} {fconfigure $f -encoding cp1251}
set data [split [read $f] \n]
close $f
if {![llength $data]} {putserv "PRIVMSG $chan : ."; return 0}
putserv "PRIVMSG $chan :$::gcolor(14) :$::gcolor(5) [llength $data]$::gcolor(14),  :$::gcolor(6) [load:bytify [fsize [file size $base]]]."
}

proc optimize {mode nick uhost hand chan text} {
variable base
variable cl_cache
set f [open $base r]
if {[encoding system] ne "cp1251"} {fconfigure $f -encoding cp1251}
set data [lreverse [split [read $f] \n]]
close $f
if {![llength $data]} {putserv "PRIVMSG $chan :$nick, Database is empty!"; return 0}
set len [llength $data]
set list [list]
set out [list]
set i 0
foreach _ $data {
if {![string is space [lindex $_ 0]] && [lindex $_ 0] in $list} {continue}
lappend list [lindex $_ 0]
lappend out $_
incr i
}

if {$mode eq 0} {
if {[expr $len - $i] < 10} {
putserv "PRIVMSG $chan :$nick, I found too small records..."
return
}
putserv "PRIVMSG $chan :Please confirm to delete [expr $len - $i] records. \[1-yes\]. You have 50 seconds."
set bind [bind pub n 1 "::vseen::optimize 1"]
set cl_cache [after 50000 "catch {unbind pub n 1 {::vseen::optimize 1};putserv \"PRIVMSG $chan :Selection timeout. Database not changed.\"}"]
}
if {$mode eq 1} {
if {$cl_cache ne "" && ![string is space [after info $cl_cache]]} {
catch {after cancel $cl_cache}
set cl_cache ""
}
set f [open $base w+]
if {[encoding system] ne "cp1251"} {fconfigure $f -encoding cp1251}
foreach _ $out {
puts $f $_
}
close $f
putserv "PRIVMSG $chan :Done. Database now contents $i records. [expr $len - $i] records has been deleted."
catch {unbind pub n 1 {::vseen::optimize 1}}
}
}

proc clear {min hour day month year} {
variable base
variable expire
variable debug
if {$debug} {putlog "\[vseen\] clearing database..."}
set f [open $base r]
if {[encoding system] ne "cp1251"} {fconfigure $f -encoding cp1251}
if {[catch {set data [lsort -index 3 -decreasing -real [lrange [split [read $f] \n] 0 end-1]]} err]} {
close $f
putlog "\[vseen\] error clearing -aborting. bad database. info $err"
return
}
close $f

if {![llength $data]} {return 0}
set tlen [llength $data]
set ff [open "$base\.new" w+]
if {[encoding system] ne "cp1251"} {fconfigure $f -encoding cp1251}
set i 0
set tmp [list]
set out [list]
foreach _ $data {
if {$_ eq {}} {continue}
if {[lindex $_ 0] in $tmp} {continue}
lappend tmp [lindex $_ 0]
lappend out $_
set vtime [lindex $_ 3]
if {[string is space $vtime]} {unset -nocomplain data; putlog "\[vseen\] corrupted database! aborting..."; break; return 0}
if {[expr [clock seconds] - $vtime] >= $expire} {incr i; continue}
puts $ff $_
}
unset -nocomplain data
close $ff
if {$i > 0} {
file delete $base
file rename "$base\.new" $base
putlog "\[vseen\] $i records has deleted."
}
if {[set len [llength $out]] > 0} {
putlog "\[vseen\] optimizing complete. removed [expr $tlen - $len] records"
set f [open $base w]
if {[encoding system] ne "cp1251"} {fconfigure $f -encoding cp1251}
puts $f [join $out "\n"]
close $f
}
}

if {[string is space [info command ::fsize]]} {proc fsize {args} {return $args}}
proc vjoin {nick uhost hand chan} {
variable base
set f [open $base a+]
if {[encoding system] ne "cp1251"} {fconfigure $f -encoding cp1251}
puts $f "[list $nick] [list $nick!$uhost] [list $chan] [clock seconds] join {} {}"
close $f
}

proc vchjn {bot user arg0 flag arg1 host} {
variable base
set f [open $base a+]
if {[encoding system] ne "cp1251"} {fconfigure $f -encoding cp1251}
puts $f "[list $user] [list $user!$host] partyline [clock seconds] chjn [list $bot] {}"
close $f
}

proc vchon {bot user arg0 flag arg1 host} {
variable base
set f [open $base a+]
if {[encoding system] ne "cp1251"} {fconfigure $f -encoding cp1251}
puts $f "[list $user] [list $user!$host] partyline [clock seconds] chon [list $bot] {}"
close $f
}

proc vchof {bot user arg0 flag arg1 host} {
variable base
set f [open $base a+]
if {[encoding system] ne "cp1251"} {fconfigure $f -encoding cp1251}
puts $f "[list $user] [list $user!$host] partyline [clock seconds] chof [list $bot] {}"
close $f
}

proc vchpt {bot user arg0 arg1} {
variable base
set f [open $base a+]
if {[encoding system] ne "cp1251"} {fconfigure $f -encoding cp1251}
puts $f "[list $user] [list $user] partyline [clock seconds] chpt [list $bot] {}"
close $f
}

proc vsplt {nick uhost hand chan} {
variable base
set f [open $base a+]
if {[encoding system] ne "cp1251"} {fconfigure $f -encoding cp1251}
puts $f "[list $nick] [list $nick!$uhost] [list $chan] [clock seconds] splt {} {}"
close $f
}

proc vrejn {nick uhost hand chan} {
variable base
set f [open $base a+]
if {[encoding system] ne "cp1251"} {fconfigure $f -encoding cp1251}
puts $f "[list $nick] [list $nick!$uhost] [list $chan] [clock seconds] rejn {} {}"
close $f
}

proc vkick {nick uhost hand chan victim text} {
variable base
set f [open $base a+]
if {[encoding system] ne "cp1251"} {fconfigure $f -encoding cp1251}
puts $f "[list $victim] [list $victim![getchanhost $victim]] [list $chan] [expr [clock seconds] -1] kick [list $nick] [list $text]"
close $f
}

proc vnick {nick uhost hand chan newnick} {
variable base
set f [open $base a+]
if {[encoding system] ne "cp1251"} {fconfigure $f -encoding cp1251}
puts $f "[list $nick] [list $nick!$uhost] [list $chan] [clock seconds] nick [list $newnick] {}"
close $f
}

proc vpart {nick uhost hand chan text} {
variable base
set f [open $base a+]
if {[encoding system] ne "cp1251"} {fconfigure $f -encoding cp1251}
puts $f "[list $nick] [list $nick!$uhost] [list $chan] [clock seconds] part [list $text] {}"
close $f
}

proc vsign {nick uhost hand chan text} {
variable base
set f [open $base a+]
if {[encoding system] ne "cp1251"} {fconfigure $f -encoding cp1251}
puts $f "[list $nick] [list $nick!$uhost] [list $chan] [clock seconds] sign [list $text] {}"
close $f
}


##################
##    SEARCH
##################

proc search {text {exact 0}} {
variable base
set text [string map [list \] \\\] \[ \\\[ \$ \\\$ \\ \\\\] $text]
set f [open $base r]
if {[encoding system] ne "cp1251"} {fconfigure $f -encoding cp1251}
if {[catch {set data [lsort -index 3 -decreasing -real [lrange [split [read $f] \n] 0 end-1]]} err]} {
close $f
putlog "\[vseen\] error while searching operation! info: $err"
return "notf"
}
close $f
if {(![string match "*\\**" $text] && ![string match "*.*" "*$text*"] && ![string match "*\?*" "*$text*"]) || ($exact eq "1" && ![string match "*.*" "*$text*"])} {
if {$exact eq "1"} {
if {[catch {set i [lsearch -all -inline -exact -nocase -index 0 $data $text]} err]} {
putlog "::vseen::search Exact search by nick (indexing) error: $err"
return "notf"
}
}
if {[catch {set i [lsearch -all -inline -nocase -index 0 $data $text]} err] || [catch {set i [lsearch -all -inline -nocase -index 5 $data $text]} err]} {
putlog "::vseen::search by nick (indexing) error: $err"
set i [lsearch -all -inline -nocase $data "$text*"]
}
if {[llength $i]} {
set res [lindex $i 0]
unset -nocomplain data i
return [list $res]
}
} else {
set text_ $text
if {![string match "*\\**" $text] && [string match "*.*" $text]} {set text "*$text*"}
set i [lsearch -all -inline -nocase -index 0 $data $text]
append i " [lsearch -all -inline -nocase -index 1 $data $text]"
if {[string match "*\\**" $text_]} {append i " [lsearch -all -inline -nocase -index 5 $data $text]"}
}
if {![llength $i] || [string is space $i]} {
unset -nocomplain data
return "notf"
}
variable maxmatches
if {[llength $i] >= $maxmatches} {
unset -nocomplain data i
return "max"
}
unset -nocomplain data
return $i
}

proc pub {exact nick uhost hand chan text} {
if {[channel get $chan novseen] && $exact ne 2} { return 1 }
set text [string map {\017 ""} [stripcodes bcurag $text]]
if {[string is space $text]} {putserv "NOTICE $nick :: $::lastbind \[-force \[-\]|-bot \<bot-nick\>|-nobotnet\] \<nick/host\>.   . : -force -    , -bot -    , -nobotnet -      ."; return 0}
if {[string tolower $text] eq [string tolower $nick]} {putserv "PRIVMSG $chan :$nick, ?\)"; return 0}
if {[string tolower $text] eq [string tolower $::botnick]} {putserv "PRIVMSG $chan :$nick,   !"; return 0}
if {[onchan $text $chan] && ![onchansplit $text]} {putserv "PRIVMSG $chan :$nick,  !"; return 0}
variable bnum; variable tmpnum
set num 0; set bnum 0; set tmpnum 0
if {[regexp -- {^-force\s-?(\d)?} $text -> num]} {
regsub -- {^-force\s-?(\d)?} $text "" text
set text [string trim $text]
putlog "\[vseen\] forcebly trying botnet seen for request '$text' from $nick ($uhost) $chan ...";
variable bchan; variable bnick; 
if {$num > 0 && $num <= 9} {set bnum $num} {set bnum 0}
set bchan $chan; set bnick $nick; set tmpnum 0
putallbots "gseen_req $text $nick $uhost $chan" 
return 0
}
if {[regexp -- {^-bot\s(.*?)\s} $text -> bot]} {
regsub -- {^-bot\s.*?\s} $text "" text
if {$bot ni [bots]} {putserv "PRIVMSG $chan :$nick,   '$bot'     ..."; return}
putlog "\[vseen\] forcebly trying botnet seen (bot $bot) for request '$text' from $nick ($uhost) $chan ...";
variable bchan; variable bnick
set bchan $chan; set bnick $nick
putbot $bot "gseen_req $text $nick $uhost $chan" 
return 0
}
set nobotnet 0
if {[regexp -- {^-nobotnet\s} $text]} {
regsub -- {^-nobotnet\s} $text "" text
set nobotnet 1
}
foreach _ [channels] {
if {[onchan $text $_] && ![onchansplit $text]} {putserv "PRIVMSG $chan :$::gcolor(5)$text $::gcolor(14)     $::gcolor(5) $_$::gcolor(14).  [duration [expr [getchanidle $text $_] * 60]]."; return 1}
}
if {![string is space [set line [useronpartyline $text check]]]} {
if {![string is space [lindex $line end]]} {set away ",   away ([lindex $line end]\017)."} {set away "."}
if {[string is digit [set idle [lindex $line 4]]]} {
if {$idle > 0} {set idle "  [duration [expr $idle * 60]]."} else {set idle ""}
}
putserv "PRIVMSG $chan :$::gcolor(5)$text $::gcolor(14)([lindex $line 2])    $::gcolor(6) [lindex $line 1]$away$idle"
return
}
if {[llength [bots]] > 1} {
if {$text in [bots]} {
putserv "PRIVMSG $chan :$::gcolor(5)$text $::gcolor(14)()    ."
return
}
}
variable base
set ::vseen::start_time [clock clicks -milliseconds]
set i 0
set results [list]
set founds [list]
set tmp [list]
variable maxmatches
set data [search $text $exact]
set total [llength $data]
if {$data eq "notf"} {
putserv "PRIVMSG $chan :  .";
if {$nobotnet eq "0"} {
putlog "\[vseen\] trying botnet seen for request '$text' from $nick ($uhost) $chan ...";
variable bchan; variable bnick
set bchan $chan; set bnick $nick
putallbots "gseen_req $text $nick $uhost $chan" 
}
return 0
}
if {$data eq "max"} {
putserv "PRIVMSG $chan :$nick,      -     '$text' -  $maxmatches."; return
}
set tdata [list]
foreach _ $data {
if {[string is space $_]} {continue}
lassign $_ vnick vhost vchan vtime vtype varg1 varg2
set vhost [lindex [split $vhost "!"] end]
if {$vnick in $tmp || $vhost in $tmp} {continue}
lappend tmp $vnick
lappend tmp $vhost
lappend tdata $_
}
set rdata [lrange $tdata 0 4]
set ftotal [llength $tdata]
foreach _ $rdata {
if {[string is space $_]} {continue}
lassign $_ vnick vhost vchan vtime vtype varg1 varg2
set vhost [lindex [split $vhost "!"] end]
lappend founds $vnick
set msg "        ."
if {[validchan $vchan] && [onchan $varg1 $vchan] && ![onchansplit $varg1] && $vtype ne "kick"} {set msg ".$::gcolor(5) $varg1 $::gcolor(14)  ."}
if {[validchan $vchan] && [onchan $vnick $vchan] && ![onchansplit $vnick] && $vtype ne "kick"} {set msg ".$::gcolor(5) $vnick $::gcolor(14)  ."}
if {[set tmppubm [pubmtext $vnick $vchan]] ne 0} {
if {[string length $tmppubm] >= 100} {set tmppubm "[string range $tmppubm 0 99]..."}
append msg "    : \<$::gcolor(6)$tmppubm\017$::gcolor(14)\>"
unset -nocomplain tmppubm
}
switch -- $vtype {
nick {lappend results "$::gcolor(4)$vnick$::gcolor(14) ($::gcolor(4)$vhost$::gcolor(14))     $::gcolor(5) $varg1 $::gcolor(14) $::gcolor(5) $vchan$::gcolor(14) [duration [expr [clock seconds] - $vtime]]  ([rustime $vtime])$msg"}
kick {lappend results "$::gcolor(4)$vnick$::gcolor(14) ($::gcolor(4)$vhost$::gcolor(14))    $::gcolor(5) $vchan $::gcolor(14)$::gcolor(5) $varg1 $::gcolor(14)  \<$::gcolor(6)$varg2\017$::gcolor(14)\> [duration [expr [clock seconds] - $vtime]]  ([rustime $vtime])$msg"}
join {lappend results "$::gcolor(4)$vnick$::gcolor(14) ($::gcolor(4)$vhost$::gcolor(14))   $::gcolor(5) $vchan$::gcolor(14) [duration [expr [clock seconds] - $vtime]]  ([rustime $vtime])$msg"}
splt {lappend results "$::gcolor(4)$vnick$::gcolor(14) ($::gcolor(4)$vhost$::gcolor(14))    -  $::gcolor(5) $vchan$::gcolor(14) [duration [expr [clock seconds] - $vtime]]  ([rustime $vtime])$msg"}
rejn {lappend results "$::gcolor(4)$vnick$::gcolor(14) ($::gcolor(4)$vhost$::gcolor(14))   $::gcolor(5) $vchan $::gcolor(14)  [duration [expr [clock seconds] - $vtime]]  ([rustime $vtime])$msg"}
part {if {![string is space $varg1]} {set ptext "   \<$::gcolor(6)$varg1\017$::gcolor(14)\>"} else {set ptext ""}; lappend results "$::gcolor(4)$vnick$::gcolor(14) ($::gcolor(4)$vhost$::gcolor(14))  $::gcolor(5) $vchan$::gcolor(14) [duration [expr [clock seconds] - $vtime]]  ([rustime $vtime])$ptext$msg"}
sign {if {![string is space $varg1]} {set ptext "   \<$::gcolor(6)$varg1\017$::gcolor(14)\>"} else {set ptext ""}; lappend results "$::gcolor(4)$vnick$::gcolor(14) ($::gcolor(4)$vhost$::gcolor(14))    $::gcolor(5) $vchan$::gcolor(14) [duration [expr [clock seconds] - $vtime]]  ([rustime $vtime])$ptext$msg"}
chjn {lappend results "$::gcolor(4)$vnick$::gcolor(14) ($::gcolor(4)$vhost$::gcolor(14))    $::gcolor(5) $varg1$::gcolor(14) [duration [expr [clock seconds] - $vtime]]  ([rustime $vtime])[useronpartyline $vnick]"}
chpt {lappend results "$::gcolor(4)$vnick$::gcolor(14)    $::gcolor(5) $varg1$::gcolor(14) [duration [expr [clock seconds] - $vtime]]  ([rustime $vtime])."}
default {}
}
}
unset -nocomplain data
 if {$ftotal eq 1} {set fnd "1 $::gcolor(14)"; set len ":"} elseif {$ftotal >=2 && $ftotal <=4} {set fnd "$ftotal $::gcolor(14)"; set len ":"} else {set fnd "$ftotal $::gcolor(14)  ($::gcolor(6) $total$::gcolor(14))"; set len ".  5:"}
 variable botgender
 if {$botgender eq "m"} {
 set fmsg " "
 } elseif {$botgender eq "w"} {
 set fmsg " "
 } else {
 set fmsg " "
 }
if {![string match "*\\**" $text] && ![string match "*.*" "*$text*"] && ![string match "*\\?*" $text]} {
if {![string is space [info command ::vr::out]]} {
::vr::out "$nick, [lindex $results 0]" $chan 260
} else {
putserv "PRIVMSG $chan :[lindex $results 0]"
}
} else {
if {![string is space [info command ::vr::out]]} {
::vr::out "$::gcolor(14)$fmsg$::gcolor(5) $fnd $::gcolor(14)  $len$::gcolor(5) [join [lrange $founds 0 4] "$::gcolor(14),$::gcolor(5) "]$::gcolor(14). [lindex $results 0]" $chan 260
} else {
putserv "PRIVMSG $chan :$::gcolor(14)$fmsg$::gcolor(6) $fnd $::gcolor(14)  $len$::gcolor(5) [join [lrange $founds 0 4] "$::gcolor(14),$::gcolor(5) "]$::gcolor(14). [lindex $results 0]"}
}
}

proc useronpartyline {user {mode ""}} {
if {[llength [bots]] < 2} {return ""}
set line ""
foreach _ [whom 0] {
if {[string equal -nocase $user [lindex $_ 0]]} {
set line $_
break
}
}
if {$line eq ""} {return ""}
if {[encoding system] ne "cp1251"} {set line [encoding convertfrom cp1251 $line]}
if {![string is space [lindex $line end]]} {
if {$mode eq ""} {return ".$::gcolor(5) $user $::gcolor(14)  ,   away ($::gcolor(6) [lindex $line end]\017 $::gcolor(14))"} else {return $line}
} else {
if {$mode eq ""} {return ".$::gcolor(14) $user $::gcolor(14)  ."} else {return $line}
}
}

proc duration {seconds} {
	set years [expr {$seconds / 31449600}]
	set seconds [expr {$seconds % 31449600}]
	set weeks [expr {$seconds / 604800}]
	set seconds [expr {$seconds % 604800}]
	set days [expr {$seconds / 86400}]
	set seconds [expr {$seconds % 86400}]
	set hours [expr {$seconds / 3600}]
	set seconds [expr {$seconds % 3600}]
	set minutes [expr {$seconds / 60}]
	set seconds [expr {$seconds % 60}]
	set res ""
	if {$years != 0} {lappend res [numstr_spec $years "" "" ""]}
	if {$weeks != 0} {lappend res [numstr_spec $weeks "" "" ""]}
	if {$days != 0} {lappend res [numstr_spec $days "" "" ""]}
	if {$hours != 0} {lappend res [numstr_spec $hours "" "" ""]}
	if {$minutes != 0} {lappend res [numstr_spec $minutes "" "" ""]}
	if {$seconds != 0} {lappend res [numstr_spec $seconds "" "" ""]}
	return [join $res ", "]
}

proc numstr_spec {val str1 str2 str3} {
	set d1 [expr $val % 10]
	set d2 [expr $val % 100]
	if {$d2 < 10 || $d2 > 19} {
	if {$d1 == 1} {return "$val $str2"}
	if {$d1 >= 2 && $d1 <= 4} {return "$val $str3"}
	}
	return "$val $str1"
}

bind bot - gseen_req ::vseen::botreq

proc botreq {bot key str} {
variable base
variable debug
set str [split $str]
if {[encoding system] ne "cp1251"} {set str [encoding convertfrom cp1251 $str]}
set text [lindex $str 0]
set nick [lindex $str 1]
set where [lindex $str 3]
foreach _ [channels] {
if {[onchan $text $_] && ![onchansplit $text]} {putbot $bot "gseen_rep $::gcolor(5)$nick $::gcolor(14)$where $::gcolor(5)$text $::gcolor(14)     $::gcolor(5) $_ $::gcolor(14)($::gcolor(6)[lindex $::network 0]$::gcolor(14)).  [duration [expr [getchanidle $text $_] * 60]]."; return 0}
}
if {![string is space [set line [useronpartyline $text check]]]} {
if {![string is space [lindex $line end]]} {set away ",   away ($::gcolor(6) [lindex $line end]\017 $::gcolor(14))."} {set away "."}
if {[string is digit [set idle [lindex $line 4]]]} {
if {$idle > 0} {set idle "  [duration [expr $idle * 60]]."} else {set idle ""}
}
putserv "PRIVMSG $chan :$::gcolor(5)$text $::gcolor(14)([lindex $line 2])    $::gcolor(6) [lindex $line 1]$away$idle"
return
}
variable b_cache
if {$b_cache ne "" && [string match "*$text*" "*$b_cache*"]} {
putlog "\[vseen\] cached request: $b_cache :: sending to: $bot"
putbot $bot "gseen_rep $nick $where $b_cache"
return
}
if {$b_cache ne "" && $b_cache eq "+BUSY+"} {
putlog "\[vseen\] cached request: $text, but no results - aborting..."
return
}
set data [search [split $text]]
set total [llength $data]
if {$data eq "notf"} {
putlog "\[vseen\] botreq: nothing found.; bot: $bot; request: $text  $nick ([lindex $str 2]) $where"
set b_cache "+BUSY+"
after 10000 {set ::vseen::b_cache ""
putlog "\[vseen\] cache variable cleared..."}
return 0
}
if {$data eq "max"} {
set text_ "     -     '$text'."
putbot $bot "gseen_rep $nick $where $nick, $text_"; return
}
set i 0
set results [list]
set founds [list]
set tmp [list]
variable maxmatches
set tdata [list]
foreach _ $data {
if {[string is space $_]} {continue}
lassign $_ vnick vhost vchan vtime vtype varg1 varg2
set vhost [lindex [split $vhost "!"] end]
if {$vnick in $tmp || $vhost in $tmp} {continue}
lappend tmp $vnick
lappend tmp $vhost
lappend tdata $_
}
set rdata [lrange $tdata 0 4]
set ftotal [llength $tdata]
foreach _ $rdata {
if {[string is space $_]} {continue}
lassign $_ vnick vhost vchan vtime vtype varg1 varg2
set vhost [lindex [split $vhost "!"] end]
lappend founds $vnick
set msg "        ."
if {[validchan $vchan] && [onchan $varg1 $vchan] && ![onchansplit $varg1] && $text eq $varg1} {set msg ".$::gcolor(5) $varg1$::gcolor(14)   ."}
if {[validchan $vchan] && [onchan $vnick $vchan] && ![onchansplit $vnick]} {set msg ".$::gcolor(5) $vnick$::gcolor(14)   ."}
if {[set tmppubm [pubmtext $vnick $vchan]] ne 0} {
if {[string length $tmppubm] >= 100} {set tmppubm "[string range $tmppubm 0 99]..."}
append msg "    : \<$::gcolor(6)$tmppubm\017$::gcolor(14)\>"
unset -nocomplain tmppubm
}
switch -- $vtype {
nick {lappend results "$::gcolor(4)$vnick $::gcolor(14)($::gcolor(4)$vhost$::gcolor(14))     $::gcolor(5) $varg1 $::gcolor(14) $::gcolor(5) $vchan$::gcolor(14) [duration [expr [clock seconds] - $vtime]]  ([rustime $vtime])$msg"}
kick {lappend results "$::gcolor(4)$vnick $::gcolor(14)($::gcolor(4)$vhost$::gcolor(14))    $::gcolor(5) $vchan $::gcolor(14)$::gcolor(5) $varg1 $::gcolor(14)  \<$::gcolor(6)$varg2\017$::gcolor(14)\> [duration [expr [clock seconds] - $vtime]]  ([rustime $vtime])$msg"}
join {lappend results "$::gcolor(4)$vnick $::gcolor(14)($::gcolor(4)$vhost$::gcolor(14))   $::gcolor(5) $vchan$::gcolor(14) [duration [expr [clock seconds] - $vtime]]  ([rustime $vtime])$msg"}
splt {lappend results "$::gcolor(4)$vnick $::gcolor(14)($::gcolor(4)$vhost$::gcolor(14))    -  $::gcolor(5) $vchan$::gcolor(14) [duration [expr [clock seconds] - $vtime]]  ([rustime $vtime])$msg"}
rejn {lappend results "$::gcolor(4)$vnick $::gcolor(14)($::gcolor(4)$vhost$::gcolor(14))   $::gcolor(5) $vchan$::gcolor(14)   [duration [expr [clock seconds] - $vtime]]  ([rustime $vtime])$msg"}
part {if {![string is space $varg1]} {set ptext "   \<$::gcolor(6)$varg1\017$::gcolor(14)\>"} else {set ptext ""}; lappend results "$::gcolor(4)$vnick $::gcolor(14)($::gcolor(4)$vhost$::gcolor(14))  $::gcolor(5) $vchan$::gcolor(14) [duration [expr [clock seconds] - $vtime]]  ([rustime $vtime])$ptext$msg"}
sign {if {![string is space $varg1]} {set ptext "   \<$::gcolor(6)$varg1\017$::gcolor(14)\>"} else {set ptext ""}; lappend results "$::gcolor(4)$vnick $::gcolor(14)($::gcolor(4)$vhost$::gcolor(14))    $::gcolor(5) $vchan$::gcolor(14) [duration [expr [clock seconds] - $vtime]]  ([rustime $vtime])$ptext$msg"}
chjn {lappend results "$::gcolor(4)$vnick $::gcolor(14)($::gcolor(4)$vhost$::gcolor(14))    $::gcolor(6) $varg1$::gcolor(14) [duration [expr [clock seconds] - $vtime]]  ([rustime $vtime])[useronpartyline $vnick]"}
chpt {lappend results "$::gcolor(4)$vnick $::gcolor(14)   $::gcolor(6) $varg1$::gcolor(14) [duration [expr [clock seconds] - $vtime]]  ([rustime $vtime])."}
default {}
}
}
unset -nocomplain data
if {$debug} {putlog "\[vseen\] botreq: sending result to $bot... :: request: $text  $nick ([lindex $str 2]) $where"}
if {$ftotal eq 1} {set fnd "1 $::gcolor(14)"; set len ":"} elseif {$ftotal >=2 && $ftotal <=4} {set fnd "$ftotal $::gcolor(14)"; set len ":"} else {set fnd "$ftotal $::gcolor(14)  ($::gcolor(6) $total$::gcolor(14))"; set len ".  5:"}

 variable botgender
 if {$botgender eq "m"} {
 set fmsg " "
 } elseif {$botgender eq "w"} {
 set fmsg " "
 } else {
 set fmsg " "
 }

set outmsg "$::gcolor(14)\[$::gcolor(5)\002[lindex $::network 0]\002$::gcolor(14)\]$::gcolor(5) :: $::gcolor(14)$fmsg$::gcolor(6) $fnd $::gcolor(14)  $len$::gcolor(5) [join [lrange $founds 0 4] "$::gcolor(14),$::gcolor(5) "]$::gcolor(14). [lindex $results 0]"
putbot $bot "gseen_rep $nick $where $outmsg"
set b_cache "$::gcolor(14)\[$::gcolor(5)\002[lindex $::network 0]\002$::gcolor(14)\]$::gcolor(5) :: $::gcolor(14)$fmsg$::gcolor(6) $fnd $::gcolor(14)  $len$::gcolor(5) [join [lrange $founds 0 4] "$::gcolor(14),$::gcolor(5) "]$::gcolor(14). [lindex $results 0]"
after 30000 {set ::vseen::b_cache ""; putlog "\[vseen\] b_cache variable cleared..."}
}

bind bot - gseen_rep ::vseen::botrep
variable tmpnum 0

proc botrep {bot key text} {
variable bchan; variable bnick; variable bnum; variable tmpnum
if {$bchan eq {} || $bnick eq {}} {return}
if {[encoding system] ne "cp1251"} {set text [encoding convertfrom cp1251 $text]}
if {[string match -nocase "***" $text] || [string match -nocase "****" $text] || [string match -nocase "***" $text] || [string match -nocase "****" $text] || [string match -nocase "*length*of*nicks*" $text] || [string match -nocase "*this*nick*is*a*bit*long*" $text] || [string match -nocase "*nolang*" $text]} {return}
if {$bnum > 1} {
putserv "PRIVMSG $bchan :$::gcolor(5)[incr tmpnum]. $::gcolor(14)  $::gcolor(5)$bot$::gcolor(14): [join [lrange [split $text] 2 end]]"
if {$tmpnum >= $bnum} {
set bchan {}; set bnick {}; set tmpnum 0
return
}
} else {
putserv "PRIVMSG $bchan :$::gcolor(14)  $::gcolor(5)$bot$::gcolor(14): [join [lrange [split $text] 2 end]]"
set bchan {}; set bnick {}; set tmpnum 0
}
}

proc bytify {bytes} {
for { set pos 0; set bytes [expr double($bytes)]} { $bytes >= 1024} {set bytes [expr $bytes/1024]} {incr pos}
set a [lindex {"" "" "" "" "" ""} $pos]
format "%.3f%s" $bytes $::gcolor(14)$a
}

proc rustime {seconds} {
if {$seconds ne ""} {
return [clock format $seconds -format "%d.%m.%Y %H:%M:%S"]
}
}
}